/*++++++++++++++
.IDENTIFICATION journals.h
.LANGUAGE       C
.AUTHOR         Francois Ochsenbein [CDS]
.ENVIRONMENT    Unix, CDS Catalogues
.KEYWORDS       Description of a Table
.VERSION  1.0   15-May-1991 (anafile)
.VERSION  4.0	28-Jul-1994: Create larger package
.COMMENTS       This file contains the names of files with allowed
		mixed-case, and the abbreviations for journals.
		This file is only used by tbf_load.
---------------*/
#ifndef JOURNALS_DEF
#define JOURNALS_DEF	0

			/* Mixed-case Allowed File Templates */
static char *mixed_names[] = {
    "SIMPLE.fih", 
    "Makefile",
    "ReadMe", 
};
			/* Table of Journal Abbreviations */
static char *journal[] = {		
    "ApJ", 	"Astrophys. J.",		/*  1 xxx xxxx */
    "ApJS", 	"Astrophys. J. Suppl. ",	/*  2 xxx xxxx */
    "A+A",	"Astron. Astrophys.",		/*  3 xxx xxxx */
    "A+AS",	"Astron. Astrophys. Suppl. ",	/*  4 xxx xxxx */
    "AJ",	"Astron. J.",			/*  5 xxx xxxx */
    "PASP",	"Publ. Astron. Soc. Pac.",	/*  6 xxx xxxx */
    "MNRAS",	"Mon. Not. R. Astron. Soc.",	/*  7 xxx xxxx */
    "AZh", 	"Astron. Zh.", 			/*  8 xxx xxxx */
    "PAZh", 	"Pis'ma Astron. Zh.", 		/*  9 xxx xxxx */
    "PASJ",	"Publ. Astron. Soc. Jap.",	/* 10 xxx xxxx */
    "AN", 	"Astron. Nachrichten",		/* 11 xxx xxxx */
    "AcA",	"Acta Astron.",			/* 12 xxx xxxx */
    "BaltA",	"Baltic Astron.",		/* 13 xxx xxxx */
    "other/AISAO", "Astrofizik. Issledovanija" ,	/* 1000 xxxx xx */
    "other/AN",    "free",				/* 1001 -- FREE */
    "other/ApL",   "Astrophys. Lett.",			/* 1002 */
    "other/KFNT",  "Kinematika Fiz. Nebesn. Tel.",	/* 1003 */
    "other/Obs",   "The Observatory" ,			/* 1004 */
    "other/AcA",   "free",				/* 1005 -- FREE */
    "other/PASAu", "Proc. Astron. Soc. Australia",	/* 1006 */
    "other/PBeiO", "Publ. Beijing Astron. Obs.",	/* 1007 */
    "other/RMxAA", "Rev. Mex. Astron. Astrofis.",	/* 1008 */
    "other/...f1", "free",				/* 1009 -- FREE */
    "other/PNAOJ", "Publ. Nat. Astron. Obs. Japan",	/* 1010 */
    "other/BSAO" , "Bull. Special Astrophys. Obs.",	/* 1011 */
    "other/PZ",    "Perem. Zvezdy",			/* 1012 */
    "other/SAAOC", "South Afr. Astron. Obs. Circ.",	/* 1013 */
    "other/BaltA", "free",				/* 1014 -- FREE */
    "other/AuJPA", "Australian J. Phys. Astrophys. Suppl.",	/* 1015 */
    "other/Ap"   , "Astrophysics",			/* 1016 */
    "other/ApSS" , "Astrophys. Space Sci.",		/* 1017 */
    "other/IBVS",  "IAU Inform. Bull. Var. Stars", 	/* 1018 */
    "other/PASA",  "Publ. Astron. Soc. Australia",	/* 1019 */
    "other/BASI" , "Bull. Astron. Soc. India",		/* 1020 */
    "other/Sci"  , "Science",				/* 1021 */
    "other/NewA" , "New Astron.",			/* 1022 */
    "other/ChA+A", "Chinese Astron.",			/* 1023 */
    "other/RoAJ" , "Romanian Astron. J.", 		/* 1024 */
    "other/CoSka", "Contr. Astron. Obs. Skalnate Pleso", 	/* 1025 */	
    "other/ARA+A", "Annual Rev. Astron. Astrophys.", 	/* 1026 */	
    "other/JApA" , "J. Astrophys. Astron.", 		/* 1027 */	
    "other/ChJAA", "Chinese J. Astron. Astrophys.", 	/* 1028 */	
    "other/P+SS" , "Planetary and Space Science", 	/* 1029 */	
    "other/APh"  , "Astroparticle Phys.", 		/* 1030 */	
    "other/GCN"  , "GRB Circular Network", 		/* 1031 */	
    "other/AcApS", "Acta Astrophys. Sinica",		/* 1032 */
    "other/AstBu", "Astrophys. Bull.,",                /* 1033 */
    "other/JAVSO", "J. Am. Assoc. Variable star obs.",  /* 1034 */
    "other/JAD",   "J. Astron. Data",			/* 1035 */
    "other/...f2", "free",				/* 1036 */
    "other/MmSAI", "Mem. Soc. Astron. Ital.", 		/* 1037 */
    "other/Nat",   "Nature",				/* 1038 */
    "other/A+ARv", "Astron. Astrophys. Rev.",		/* 1039 */
    "other/RAA",   "Res. Astron. Astrophys.",		/* 1040 */
    "other/PZP",   "Perem. Zvezdy Prilozh.",  		/* 1041 */
    "other/Ser",   "Serbian Astron. J.",		/* 1042 */
    "other/OEJV",  "Open European J. Var. stars",  	/* 1043 */
    "other/A+AT",  "Astron. Astrophys. Trans.",  	/* 1044 */
    "other/SoSyR", "Solar System Res.", 	 	/* 1045 */
    "other/PABei", "Progress in Astronomy (Publ. Beijing)", 	/* 1046 */
    "other/JDSO",  "J. Double Star Obs.", 	 	/* 1047 */
    "other/PDDO",  "Publ. David Dunlap Obs.",		/* 1048 */
    "other/BOBeo", "Bull. Obs. Astron. Beograd",  	/* 1049 */
    "other/PPMtO", "Publ. Purple Mountain Obs.",  	/* 1050 */
    "other/PZ",    "Perem. Zvezdy", 
    "other/AnTok", "Ann. Tokyo Astron. Obs.",
    "other/Msngr", "The Messenger",
    "other/SoSAO", "Soobshch. Spets. Astrof. Obs.",
    (char *)0
};

#endif
