/*++++++++++++++
.IDENTIFICATION vizcat.c
.LANGUAGE       C
.AUTHOR         Francois Ochsenbein [CDS]
.ENVIRONMENT    Unix, CDS Catalogues
.KEYWORDS       Table, FITS
.VERSION  1.0   20-Oct-1995
.VERSION  1.1   28-Aug-1996: wild chars allowed for table names
.VERSION  1.2   10-Jun-1997: Flag (NODB) the useless fields (---)
.VERSION  1.3   28-Aug-1997: Other flags
.VERSION  1.4   22-Jun-1998: Allow vizSQL, vizExplain
.VERSION  1.5   03-Feb-1999: Added options
.VERSION  1.6   07-May-1999: Special function tdup to duplcate formats.
.VERSION  1.7   27-Sep-1999: viz_addmore inserted.
.VERSION  1.8   05-Apr-2001: F_NODB & F_MPOS ==> Problem !!
.VERSION  1.9   16-Jun-2001: Remove the existing comments in vizExplain
.VERSION  1.91  18-Nov-2001: problem with isgraph --> isGraph
.VERSION  1.92  20-Aug-2002: accept filenames terminated by .viz
.VERSION  2.0   03-Nov-2002: tdup is now a function in catstd.c
.VERSION  2.1   11-Nov-2002: take \vizAddColumn into account
.VERSION  2.2   06-Jan-2003: viz_set: not more than 4 bytes for a position col.
.VERSION  2.3   14-Feb-2003: viz_load (all columns)
.VERSION  2.4   17-May-2003: print_head
.VERSION  2.5   29-Mar-2004: viz_more returns
				-1 = Catalog Concerned
				-2 = Table(s) concerned
.VERSION  2.51  10-Apr-2004: viz_more contns Table(s) links as column's
.VERSION  2.52  19-Apr-2004: add_param
.VERSION  2.53  26-Apr-2004: vizAddFKflag
.VERSION  2.6   10-Jul-2004: set_mpos: change also the equinox/epoch of FILE
.VERSION  2.61  10-Nov-2004: \vizLinkToNote, \vizNote
.VERSION  2.62  28-Nov-2004: -udim option in program
.VERSION  2.63  04-Feb-2005: accept vizAddCol with alternative values
			(starting by a comma ,); accept \ucd{UCD}
.VERSION  2.7   02-Apr-2005: Specification of Columns accept Wild Chars
.VERSION  2.8   29-Apr-2005: \vizAddColumn loaded from a File in case
				value starts by a .
.VERSION  2.81  09-Feb-2006: CATSTD_H to indicate the catstd.h file
.VERSION  2.82  22-Mar-2006: Accept . un UCD1's, @ in links
.VERSION  2.83  04-Apr-2006: Accept in viz2 "---" synonym of empty table list
.VERSION  2.84  27-May-2006: Error in edition of flags
.VERSION  2.85  08-Jul-2006: print_cat: take care of !e=
.VERSION  2.86  25-Jul-2006: Accept *.ext in load_values
.VERSION  2.87  05-Dec-2006: \vizAddColumn: several for the same table...
.VERSION  2.88  01-Apr-2007: Cosmetics (-Wall)
.VERSION  2.89  23-Jun-2007: Accept several UCDs (UCD1+UCD1+)
.VERSION  2.891 02-Aug-2007: . alone is NOT a file name
.VERSION  2.892 01-Sep-2007: "recno" not included in "*" columns
.VERSION  2.9   05-Nov-2007: alt_find fixed
.VERSION  2.91  20-Jan-2008: Better edition of errors in viz_set
.VERSION  2.92  22-Jan-2008: alt_find: bug when several! 2 functions:
				alt_find + alt_next.
.VERSION  2.93  30-Mar-2008: set_atext has argument 'opt';
				macros '\vizPKlink'
.VERSION  2.94  05-Oct-2008: vizAddColumn adds an ID.
.VERSION  2.95  09-Oct-2008: Check only ascii characters
.VERSION  2.96  22-Nov-2008: in column 'name', accept an order (for vizLink)
.VERSION  2.97  04-Apr-2009: Pb \vizMore replacement.
.VERSION  2.98  28-Aug-2009: add_col: may specify a EOL char
			Added viz_more3 
.VERSION  2.99  04-Aug-2011: \vizAddXcount
.VERSION  3.00  25-Sep-2011: viz_more: processed macros marked by '#' 
.VERSION  3.01  06-Oct-2011: export theCol
.VERSION  3.02  25-Oct-2011: pb adc_keyword (accept keywords separated by '-')
.VERSION  3.03  11-Feb-2012: Column with alternatives marked F_CSV
.VERSION  3.04  23-Feb-2012: option -csv+ (gives bytes)
.VERSION  3.05  29-Feb-2012: \vizAddCount
.VERSION  3.06  18-Mar-2012: \vizAddColumn: fixed bug when unit+dbunit specified
.VERSION  3.07  15-Nov-2012: set_mpos
.VERSION  3.1   24-Nov-2012: -t topn
.VERSION  3.11  09-Jan-2013: use quiet option
.VERSION  3.12  15-Jan-2013: add_column: values are REQUIRED by default
.VERSION  3.13  30-Apr-2013: Bug in case missing parameters
.VERSION  3.14  04-May-2013: \vizAddFKcount
.VERSION  3.15  28-Jun-2013: Warning for \ \n
.VERSION  3.16  23-Jul-2013
.VERSION  3.17  30-Aug-2013: Mark descriptions removed. Removed vizAddFKcount
				(use \vizAddCount{table}{col}{*FK=name }...)
.VERSION  3.18  30-Sep-2013: vizAddCount: take care of self-count ==> \ifnum>1
.VERSION  3.19  10-Nov-2013: Pb in self-count (add_columns)
.VERSION  3.20  11-Dec-2013: Pb in strNote
.VERSION  3.21  16-Dec-2013: load_values: don't do if main program 
			(loops when the executable calls vizcat)
.VERSION  3.22  05-Jan-2014: Problem in add_columns with values
.VERSION  3.23  07-Feb-2014: Mark F_LINK columns quoted in ${...}
.VERSION  3.24  08-Jul-2014: viz_load returns negative number in case of error
.VERSION  3.25  15-Sep-2014: addCount: take into account the limit in fmt=
.VERSION  3.26  05-Dec-2014: Seg. fault when add_columns fails
.VERSION  3.27  16-Dec-2014: Bug fixed in viz_set
.COMMENTS       Interpret .status and/or .Summary
	This module concerns additional interpretation of the
	ReadMe file and additional parameters in .status or .Summary.
	The "parameter" is normally written like a TeX macro, e.g.
	\cUsualName{name}, or \vizIgnoreTables{...list}
---------------*/

#define VERSION "3.27 (2014-12-16)"

#ifndef DEBUG
#define DEBUG 0
#endif
#ifndef TEST
#define TEST 0
#endif


#include <filutil.h>
#include <catstd.h>
#include <buffer.h>		/* Expandable Strings	*/
#include <ctype.h>		/* Character classes 	*/
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <sys/stat.h>
/* char *strdup() ;		-- in string.h */

static char inline_comment[] = "#;=%@!\"/\\";    /* V2.98: possible
	                   characters in input which start the comment */

#define isGraph(c)        (((unsigned)(c))>(unsigned)' ')

#if DEBUG||TEST
static char usage[] = "\
Usage: vizcat [-v] [-udim] [-csv[+][=sep]] [-f...] [-t tab] [-ucd] ReadMe_file\n\
" ;
static char help[] = "\
     -v: verbose option\n\
   -csv: Print in CSV format (defaut separator char is TAB)\n\
  -csv+: Print in CSV format, with column locations\n\
  -f...: format is described in fmt_file according to CDS standards\n\
	 (see anafile program)\n\
 -t tab: specify which table (by default, all tables)\n\
   -ucd: list the UCD values (default is to list the More links)\n\
  -udim: edit the unit dimension (in addition to the unit)\n\
" ;
static char inbyte;
static char csv, csvp;	/* CSV-output (csvp = '+' if asked) */
static char odim;	/* -udim */
static char oucd;	/* -ucd  */
static char *vizMore = "\\vizMore" ;
#endif

	/* returned strings are collected in BUFFER	*/
static BUFFER bCollect = BUF_Init(char, 128);
static BUFFER bName   = BUF_Init(char, 128);
static char *macro_name ;	/* Used by viz2 	*/
static char *arg2 ;		/* Used by viz2		*/
static char *arg3 ;		/* Used by viz2		*/
static char argid[4];		/* Used by viz2		*/
#define collect 	(&bCollect)

typedef struct { char *name; int toset; int toclear; } MACROFLAG ;
static MACROFLAG macroflags[] = {
/* List of macros with corresponding flags
   MacroName    toSet    toClear
*/
  { "\\vizIgnoreColumns", F_NODB, 0 },	/* MUST BE FIRST (done at end) */
  { "\\vizIndex", F_INDX, 0 },
  { "\\vizPK",    F_isPK, F_isFK|F_isPK },
  { "\\vizFK",    F_isFK, F_isFK|F_isPK },
  { "\\vizPFK",   F_isFK|F_isPK, 0 },
  { "\\vizCatK",  F_CATA, 0 },
  { "\\vizSimK",  F_SIMB, 0 },
  { "\\vizHTML",  F_HTML, F_HTML|F_TeX|F_sofTeX },
  { "\\vizTeX",   F_TeX, F_HTML|F_TeX|F_sofTeX },
  { "\\vizSoft",  F_sofTeX, F_HTML|F_TeX|F_sofTeX },
  { "\\vizCSV",   F_CSV, F_HTML|F_TeX|F_sofTeX },
  { "\\vizPKlink", F_isPK, F_isFK|F_isPK },
  { "\\vizFKlink", F_isFK, F_isFK|F_isPK },
  { "\\vizPFKlink", F_isPK, F_isFK|F_isPK },
  { "\\vizLinkToNote",  F_Lnote, 0},
  { "\\vizNoLink",   0, F_Lnote},
  { (char *)0 }
} ;

static int nerrs = 0 ;		/* Number of errors,
				retrieved and reset by viz_errs */
static CATINFO *theCat;		/* Used in set_mpos */
static int keep_allocated_more = 0;	/* 1=don't free; 2=mark as processed */
/*static int maxlen_values = 0;		-- use as a parameter (V3.22) */

/* Flags used to mark the status of the tables */
#define TFLAG_DISP	0x01	/* \vizDisplayColumns */
#define TFLAG_MPOS	0x04	/* \visPosition       */

/* Structure containing the list of alternatives */
struct more_alternatives {
   struct more_alternatives *next;	/* Chained list */
   char *more;				/* Text */
   short maxlen;			/* Length of longest item */
   short offset;			/* Where in the more text */
   short len;				/* Current item length    */
   short isalist;			/* Is a list of items     */
};

/*==================================================================
		Verify a text is a note
 *==================================================================*/

static int strNote(char *text)
/*++++++++++++++++
.PURPOSE  Verify the text includes a note
.RETURNS  Index of note (e.g. index of "G1)") / -1
.REMARKS  Note number MUST BE < 100
-----------------*/
{
  char *p;
  int n;
    if (!text) return(-1);
    if (!*text) return(-1);
    for (p = text+strlen(text)-1; (p>text) && isspace(*p); p--) ;
    if (*p != ')') return(-1);
    for (--p; (p>text) && (*p != '('); p--) ;
    if (p == text) return(-1);
    ++p;  if(*p == 'G') p++;
    n = atoi (p);
    /* V3.20: pf in note e.g. (1AGL) */
    if ((n>0) && (n<100)) {
	for (n=0; isdigit(p[n]); n++) ;
	if ((p[n] == '(') && (n<3)) return(p-text);
    }
    return(-1);
}

static int strbrace(arg)
/*++++++++++++++++
.PURPOSE  Compute the length of a string
.RETURNS  The length (index of closing brace)
-----------------*/
  char *arg;		/* IN: Text starting by '{'	*/
{
  char *e ; int dp ;
    dp = 0 ;
    if (*arg != '{' /*}*/)
	e = arg + strloc(arg, '\n') ;
    else for (dp=1, e=arg+1; *e ; e++) {
	if (*e == '{') dp++ ;
	else if (*e == '}') { if (--dp <= 0) break ; }
    }
    if (dp) fprintf(stderr, "++++non-closed brace %s\n", arg) ;
    return(e-arg) ;
}

/*==================================================================
		Matching file names
 *==================================================================*/
static int match_file(char *template, char *filename)
/*++++++++++++++++
.PURPOSE  Compare two file names.
.RETURNS  1 (match) / 0 (mismatch)
.REMARKS  filename may be terminated by .dat or by .viz
-----------------*/
{
  int i, k ;

    if ((k = strmatch(template, filename))) 	/* Match ! */
	return(k) ;

    i = strloc(filename, '.') ;
    if ((strcmp(filename+i, ".dat") != 0) &&
	(strcmp(filename+i, ".viz") != 0)) return (0) ;

    /* Filename is something like *.dat. */
    filename[i] = 0 ;
    k = strmatch(template, filename) ;
    filename[i] = '.' ;
    return(k) ;
}

static int match_list(char *list, char *filename)
/*++++++++++++++++
.PURPOSE  Indicates the file is in the list
.RETURNS  >=1 (match index) / 0 (mismatch)
.REMARKS  Ignore file extension if non given in list
-----------------*/
{
  char local_file[40];
  int i, n=0;
    if (*list == '=') return(1);	/* V3.25: '=' as table always matches */
    if((!strchr(list,'.')) && (strlen(filename)<sizeof(local_file))) {
	strncpy(local_file, filename, sizeof(local_file));
	local_file[strloc(local_file, '.')] = 0;
	filename = local_file;
    }
    while(*list) {
	n++;
	if (*list == ',') list++;
	for(i=0; filename[i]&&(filename[i]==list[i]); i++) ;
	if ((filename[i]==0)&&((list[i]==',')||(!isgraph(list[i]))))
	    return(n+1);
	for(i=0;(filename[i]==list[i])&&filename[i]; i++) ; 
	if ((filename[i]==0)&&((list[i]==',')||(!isgraph(list[i])))) 
	    return(n);
	list += strloc(list, ',');
    }
    return(0);
}

static int set_fflags(cad, template, flags, value)
/*++++++++++++++++
.PURPOSE  Set the flags (1 byte per file) for data files which match the
	specified template.
.RETURNS  Number of changed flags
.REMARKS  Should work also for *.dat files...
-----------------*/
  CATINFO *cad;		/* IN: The ReadMe block	*/
  char *template ;	/* IN: The template(s)	*/
  char *flags ;		/* MOD: Byte flags	*/
  int value ;		/* IN: Value to set in	*/
{
  char *t, x ;
  int i, j, m, n, nodb ;
  FILINFO *file ;

    n = nodb = 0 ;
    for (t=template; *t; t += i) {
	i = strloc(t, '\t') ;
	x = t[i] ; t[i] = 0 ;
    	for (m=j=0, file=cad->afinfo; j<cad->nfinfo; j++, file++) {
	    if (!file->tabform) {
		if (file->flags&F_NODB) nodb++; /* Added V3.16 */
		continue ; /* Only described files! */
	    }
	    if (match_file(t, file->dfile)) m++, flags[j] = value;
	}
	if ((m == 0) && (nodb == 0)) {
	    fprintf(stderr, "++++") ;
	    if (macro_name) fprintf(stderr, "%s: ", macro_name) ;
	    fprintf(stderr, "No table matches '%s'\n", t) ;
	}
	if ((t[i] = x)) t++ ;
	n += m ;
    }
    return(n) ;
}

static int mark_link(void *table, char *text, COLINFO *column)
/*++++++++++++++++
.PURPOSE  Mark with F_LINK the columns quoted in the text as ${...}
.RETURNS  Number of columns marked
0REMARKS  Adde V3.23
-----------------*/
{
  static char *bs = "${", *es = "}$";
  COLINFO *col;
  char *t=text;
  int count=0, c, i;
    while((t=strstr(t, bs))) { 
	t += 2; while((*t == '*')||(*t == '=')) t++; /* Accept e.g. ${**Name} */
	for(i=0; isgraph(t[i]) && (t[i]!=es[0]) && (t[i]!=es[1]); i++) ;
	if (i<1) continue;	/* Not a column */
	c = t[i]; t[i] = 0;
	if ((col = tbf_findcol(table, t))) {
	    if (col != column) col->flags |= F_LINK;
	    count++;
	}
	else fprintf(stderr, "#+++Column ${%s} could not be found!\n", t);
	t[i] = c;
    }
    return(count);
}

static int flag_tabs(cad, fflags, tflags, value)
/*++++++++++++++++
.PURPOSE  Flag with 'value' in "tflags" array from "fflags" array
	(i.e. report the FILES flagged to Byte-by-byte Descriptions)
.RETURNS  Number of "tflags" elements actually flagged.
-----------------*/
  CATINFO *cad;		/* IN: The ReadMe block	*/
  char *fflags ;	/* IN:  FILINFO flags	*/
  char *tflags ;	/* MOD: TABINFO flags	*/
  int value ;		/* IN: 0 for copy	*/
{
  FILINFO *file ;
  TABINFO *t ;
  int i, j, m ;

    m = 0 ;
    for (j=0, file=cad->afinfo; j<cad->nfinfo; j++, file++) {
	if (!(fflags[j]&1)) continue ;
	t = file->tabform ;
	if (!t) continue ;
	i = t - cad->atinfo ;
	if (!(tflags[i]&value)) m++ ;
	tflags[i] |= value ;
    }
    return(m) ;
}

/*==================================================================
		Dealing with alternatives
 *==================================================================*/

static char *alast_tab(char *text, int nelems)
/*++++++++++++++++
.PURPOSE  Locate the address of (end+1) tab-separated-element.
.RETURNS  Pointer to end of valid text.
-----------------*/
{
  char *atab;
    atab = text +  strloc(text, '\t');
    while (*atab) {
	if (--nelems <= 0) break;
	atab++;
	atab += strloc(atab, '\t');
    }
    return(atab);
}

static char *alt_next(struct more_alternatives *list)
/*++++++++++++++++
.PURPOSE  Move to next alternative (in vizAddColumn)
.RETURNS  list->more + list->offset; NULL in case of error
.REMARKS  Introduced in V2.95
-----------------*/
{
    if (list->isalist) { char *p; int i;
	list->offset += list->len;
        p = list->more + list->offset;
        if (*p == ',') { p++; list->offset += 1; }
        for (i=0; isprint(p[i]) && (p[i] != ','); i++) ;
        list->len = i;
	return(p);
    }
    return((char *)0);
}

static struct more_alternatives *alt_find(
/*++++++++++++++++
.PURPOSE  Find in the list of alternatives the matching one
.RETURNS  The (eventually newly allocated) alternative
.REMARKS  Used in vizAddColumn when the value starts by a ,
	V2.95: the alternative is NOT incremented
	(use alt_next for that)
-----------------*/
    struct more_alternatives *list,
    char *text,
    int  nfields,	/* 5 = number of fields in AddColumn */
    int  valno)		/* in range [0, nfields[ */
{
  struct more_alternatives *a, *n, *a0;
  char *p, *tab_saved;
  int i;

    /* V2.9: be sure first text is effectively a single alternative ? */
    tab_saved = alast_tab(text, nfields);
    if (*tab_saved) *tab_saved = 0;
    else tab_saved = (char *)0;

    for (a=list; a; a = a->next) {
	if (strcmp(text, a->more) == 0) break;
    }
    a0 = a;

    if (a) { 	/* Already exists...*/
	if (tab_saved) *tab_saved = '\t';
#if 0	/* V2.92: incrementation is done in alt_next() */
        if (a->isalist) {
	    a->offset += a->len;
            p = a->more + a->offset;
            if (*p == ',') { p++; a->offset += 1; }
            for (i=0; isprint(p[i]) && (p[i] != ','); i++) ;
            a->len = i;
        }
#else
	return(a);
#endif
    }
    else   {	/* Need a new allocation */
      Next1:
	a = malloc(sizeof(struct more_alternatives));
	a->next = (struct more_alternatives *)0;
	a->more = strdup(text);
	a->len = a->maxlen = 0;
	if (!a0) a0 = a;
	/* Find the nth value */
	for (p=a->more, i=valno; i>0; i--) {
	    p += strloc(p, '\t');
	    if (*p) p++;
	}
	a->offset = p - a->more;
	p = a->more + a->offset;
	a->isalist = (*p == ',');
	if (a->isalist) {
	    p++; 		/* Skip first comma    */
#if 0	/* V2.92: incrementation is done in alt_next() */
	    a->offset += 1;	/* Skip first comma */
	    for (i=0; isprint(p[i]) && (p[i] != ','); i++) ;
	    a->len = a->maxlen = i;
#else
	    a->len = 1;		/* To get the first value */
	    a->maxlen = 0;
#endif
	    while (isprint(*p)) {	/* Compute the max length */
	        for (i=0; isprint(p[i]) && (p[i] != ','); i++) ;
	        if (i > a->maxlen) a->maxlen = i;
	        p += i;
	        if (*p == ',') p++;
	    }
	}
	else {				/* Compute the total length */
	    for (i=0; isprint(p[i]); i++) ;
	    a->len = a->maxlen = i;
	}
	if (list) {	/* Set the chain */
	    for (n=list; n->next; n = n->next) ;
	    n->next = a;
	}
	else list = a;
	/* V2.87: there may be more vizAddColumn's */
	if (tab_saved) {	/* Updated V2.9 */
	    *(tab_saved++) = '\t';
	    text = tab_saved;
            tab_saved = alast_tab(text, nfields);
            if (*tab_saved) *tab_saved = 0;
            else tab_saved = (char *)0;
	    goto Next1;
	}
	/*
	a = list;
	return(list);
	*/
    }

    return(a0);
}

static void alt_free(struct more_alternatives *list)
/*++++++++++++++++
.PURPOSE  Free the chain allocated by alt_find
.RETURNS  ---
-----------------*/
{
    if (!list) return;
    if (list->next) alt_free(list->next);
    free(list->more);
    memset(list, 0, sizeof(struct more_alternatives));
}


/*==================================================================
		Dealing with the associated file
 *==================================================================*/

static int load_more(cad)
/*++++++++++++++++
.PURPOSE  Load the associated .status
.RETURNS  0 (OK) / -1 (error)
.REMARKS  Remove the blanks following ending \
-----------------*/
  CATINFO *cad;	/* MOD: The ReadMe block	*/
{
  char filename[256];
  char *p, *s, *b;
  int nerr=0;
  int i;

    if (cad->flags&CAT_more)	/* Already done */
	return(0) ;
    if (cad->flags&CAT_obs) {	/* =obsolete= loaded */
	cad->flags &= ~CAT_obs ;
	free(cad->more) ;
    }

    /* Build up the name from "ReadMe": keep dirname, append .Summary */
    i = 1 + strbloc(cad->filename, '/');
    if (i >= sizeof(filename)-10) {
    	fprintf(stderr, "****Filename too long (load_more) %s\n",
		cad->filename);
    	return(-1);
    }
    cad->flags |= CAT_more ;
    strncpy(filename, cad->filename, i);

    /* Try first with ".status"	*/
    strcpy(filename+i, ".status");
    if ((cad->more = load_file(filename, 0)))
      goto JoinLines;

    /* Try ".Summary"		*/
    strcpy(filename+i, ".Summary");
    if ((cad->more = load_file(filename, 0)))
      goto JoinLines;

    /* No possibility...	*/
    cad->more = (char *)malloc(1);
    *(cad->more) = 0;
    return(0);

  JoinLines:	/* Take care of lines ending by \ : skip the spaces... */
    /* Buffer is rewritten: s=input, p=output, b=start of output line  */
    p = s = b = cad->more ;
    while (*s) {
	if ((*s=='%')&&(b==p)) { /* A comment, starts by % (V3.23) */
	    s += strloc(s, '\n');
	    if (*s) s++;
	    continue;
	}
	if ((s[0] == '\\') && isspace(s[1])) /*(s[1] == '\n')*/ { /* V3.15 */
	    if (s[1] == '\n') {
	        for (++s; isspace(*s); s++) ;
	        continue ;
	    }
	    for(i=1; (s[i]==' ')||(s[i]=='\t'); i++) ;
	    if (s[i] == '\n') { /* V3.15 */
		fprintf(stderr, "#+++%s: Blank after \\ at end-of-line:\n#...",
			filename);
		fwrite(b, 1, (s-b)+i, stderr); fprintf(stderr, "\n#   ");
		for(++i; (i<60)&&(s[i]!='\n'); i++) fputc(s[i], stderr);
		if(s[i]!='\n') fprintf(stderr, "...");
		fputc('\n', stderr);
	    }
	}
	i = *(s++) ;
	/* TABs in .Summary or .status give problem -- replace by blank	*/
	if (i == '\t') i = ' ' ;
	*(p++) = i ;
	if (i == '\n') b = p;
	else if (i&0x80) {	/* Added V2.95 */
	    fprintf(stderr, "#***Non-ascii character \\%03o in %s:\n",
		    i&0xff, filename);
	    fwrite(b, 1, p-b, stderr);
	    fprintf(stderr, "...\n");
	    nerr++;
	}
    }
    if (nerr) exit(1);
    while (p<s) *(p++) = 0;

    /* V2.82: Accept . in UCD1... */
    p = cad->more;
    while ((p = strstr(p, "\\vizUCD"))) {
	p += strloc(p, '{' /*'}'*/); p += strbrace(p);	/* Skip first arg.*/
	p += strloc(p, '{' /*'}'*/); p += strbrace(p);	/* Skip 2nd   arg.*/
	p += strloc(p, '{' /*'}'*/);                  	/* In   3rd   arg.*/
	s = p + strloc(p, '=');      p += strbrace(p);
	if ((s<p) && isupper(s[1])) 	/* UCD1 context. Replace . by _ */
	while ((s<p) && isgraph(*s)) {
	    if (s[1] == '.') {
		if (isdigit(s[0]) && isdigit(s[2])) ;
		else s[1] = '_';
	    }
	    s++;
	}
    }

    /* ... and replace @{...} or `{...} in Links, e.g.
     *     @{Name@1-3} by ${Name$1-3},
    */
    p = cad->more;
    while ((p = strstr(p, "@{" /*"}"*/))) {
	*(p++) = '$';
	s = p; p += strbrace(p);
	while (s < p) {
	    if (*s == '@') *s = '$';
	    s++;
	}
    }

    /* ... and replace `{...} in Links, but not \`{e}...
     *     `{`cat} by ${$cat}, etc
    */
    p = cad->more;
    while ((p = strstr(p, "`{" /*"}"*/))) {
	if (p[-1] == '\\') { p++; continue; }
	*(p++) = '$';
	s = p; p += strbrace(p);
	while (s < p) {
	    if (*s == '`') *s = '$';
	    s++;
	}
    }

    return(0);
}

static int next(text, macro)
/*++++++++++++++++
.PURPOSE  Locate the next text (line must start with \)
.RETURNS  Index in text of the word following "text" / length of text
.REMARKS  a blank macro is possible !
	Text marked as used when (keep_allocated_more&2) [V3.00]
-----------------*/
  char *text;		/* IN: Text to scan   */
  char *macro;		/* IN: Macro to locate, starting by \	*/
{
  char *n, *t; int i=0;

    for (t=text; *t; t = n) {
    	if (*t == '\n') { n = t+1; continue; }
    	n = t + strloc(t, '\n');
    	for (i=0; macro[i] && (macro[i]==t[i]); i++) ;
    	if (macro[i]) continue;	/* Macro not found */
    	if (!isalnum(t[i])) break;
    }
    if (!*t) return(t-text);
    /* V3.00: Mark the macro as USED */
    if ((keep_allocated_more&2) && (*t == '\\')) *t = '#';
    /* Remove blanks before '{' if existing }*/
    t += i;
    if (isspace(*t)) {
	for (n=t; isspace(*n); n++) ;
	if (*n == '{' /*}*/) t = n ;
    }
    return(t-text);
}

static int append_arg(b, arg)
/*++++++++++++++++
.PURPOSE  Insert into buffer a string, stopping at closing brace
.RETURNS  Bytes used in arg
.REMARKS  Removes the HEADING and TRAILING spaces
-----------------*/
  BUFFER *b;		/* MOD: Buffer to fill	*/
  char *arg;		/* IN: Text starting by '{'	*/
{
  char *cb, *a, *e ;
    a = arg ;
    e = cb = a + strbrace(a) ;
    if (*a == '{') a++ ;
    if (*cb == '}') cb++ ;			/* Match Closing Brace	*/
    while ((a < e) && isspace(*a)) a++ ;	/* Remove Heading Space */
    while ((a < e) && isspace(e[-1])) e-- ;	/* Remove Tailing Space */
    BUF_AppendItems(b, char, a, (e-a)) ;
    BUF_AppendString(b, "") ;

    return(cb - arg) ;
}

static int append_names(b, names)
/*++++++++++++++++
.PURPOSE  Interpret "names" which includes a set of names separated
	  by blanks --- eventually with comma FOLLOWED by a blank.
	  Names are accumulated in buffer 'b', where the names are
	  separated by a TAB
.RETURNS  How many bytes have been matched in "names"
.REMARKS  If the string starts by '{', it stops with '}'
-----------------*/
  BUFFER *b;		/* MOD: Buffer to fill	*/
  char *names;		/* IN: Text starting by '{'	*/
{
  char *p, *w, cstop; int d; static char sep = '\t';
    p = names; cstop = 0;
    if (*p == '{') cstop = '}', p++;
    while (*p) {
    	while (isspace(*p)) p++;
    	if ((*p == ',') || (*p == ';') || (*p == ':')) p++;
    	while (isspace(*p)) p++;
    	w = p;			/* Beginning of Word	*/
    	if (*p == cstop) break;	/* Indicates end scan	*/
    	else if (*p == '{' /*}*/) {	/* Match token '{...}'	*/
    	    p++, d = 1;
    	    while ((d>0) && (*p)) {
    	    	if (*p == '{') d++;
    	    	if (*p == '}') d--;
    	    	p++;
    	    }
    	    if (d != 0) fprintf(stderr, "++++non-closed brace %s\n", w);
    	}
    	else {			/* Match single Word	*/
	    d = 0;
    	    while (isGraph(*p) && (*p != cstop) && (d == 0)) {
		if (*p == '{') d++;
		if (*p == '}') d--;
		p++;
	    }
    	    if (p[-1] == ',') p--;
    	    else if (p[-1] == ';') p--;
    	    else if (p[-1] == ':') p--;
    	}
    	if (b->used) BUF_AppendItem(b, char, &sep);
	while (w < p) {
	    if (*w != '\\') BUF_AppendItem(b, char, w);
	    w++;
	}
    }

    if (cstop) {
    	if (*p == cstop) p++;
    	else fprintf(stderr,  "++++non-closed brace %s\n", names);
    }
    cstop = 0 ;
    BUF_AppendItem(b, char, &cstop) ;	/* Terminating NUL */
    b->used -= 1 ;
    return(p-names);
}

#if 0
static int viz1(cad, string, flags)
/*++++++++++++++++
.PURPOSE  Interpret the argument representing a set of FileNames, and set flags
	  to 1 the  FILES concerned
	  to 2 the TABLES concerned
.RETURNS  Number of Files concerned (0 ==> concerns the Catalog)
.REMARKS  The static macro_name contains the Macro in case of error
	The next argument is saved in bCollect.buf
-----------------*/
  CATINFO *cad;		/* IN: The ReadMe block		*/
  char *string ;	/* IN: The string to interpret	*/
  char *flags ;		/* MOD: |1 (FILES) |2 (TABLES)  */
{
  char *t ;
  int n ;

    memset(flags, 0, cad->nfinfo) ;
    t = string ;
    BUF_Clear(&bName) ;
    append_names(&bName, t) ;
    n = set_fflags(cad, bName.buf, flags, 1) ;
    if (n>0) flag_tabs(cad, flags, flags, 2) ;

    /* Locate Second Argument */
    t += strloc(t, /*{*/ '}') ;
    if (*t) t++ ;
    while (isspace(*t)) t++ ;
    BUF_Clear(&bCollect) ; BUF_AppendString(&bCollect, "") ;
    if (*t == '{' /*}*/) append_arg(&bCollect, t) ;
    else fprintf(stderr, "++++Second argument missing for %s{%s}\n",
	macro_name, bName.buf) ;
    return(n) ;
}
#endif

static char *viz2(cad, string, flags)
/*++++++++++++++++
.PURPOSE  In addition to viz1 (interpretation of list of tables),
	  interpret the set of columns
.RETURNS  The tab-separated list of Columns (=bCollect.buf) /
	  NULL if concerns whole catalog
	  ""   if no column concerned,
.REMARKS  The static macro_name contains the Macro (for error messages)
-----------------*/
  CATINFO *cad;		/* IN: The ReadMe block		*/
  char *string ;	/* IN: The string to interpret	*/
  char *flags ;		/* MOD: |1 (FILES) |2 (TABLES)  */
{
  char *t, *loc ;
  int i ;

    memset(flags, 0, cad->nfinfo) ;
    t = string ;
    BUF_Clear(&bName) ;
    append_names(&bName, t) ;
    /* V2.83: Name made of --- is equivalent to empty string */
    for (i=0; (i<bName.used) && bName.buf[i] == '-'; i++);
    if (bName.used == i) {
	BUF_Clear(&bName);
	if (bName.buf) bName.buf[0] = 0;
    }
    loc = bName.used == 0 ? (char *)0 : (char *)1 ;

    /* loc is NULL when comment refers to CATALOG */
    if ((!set_fflags(cad, bName.buf, flags, 1)) && loc) {
	fprintf(stderr, "++++No file matched in %s", macro_name) ;
	i = strloc(string, '\n');
	if (i < 50) fwrite(string, 1, i+1, stderr) ;
	else fwrite(string, 1, 56, stderr), fprintf(stderr, "...\n") ;
	return((char *)0) ;
    }
    if (loc) flag_tabs(cad, flags, flags, 2) ;

    /* Locate Second Argument */
    t += strloc(t, /*{*/ '}') ;
    if (*t) t++ ;
    while (isspace(*t)) t++ ;
    /* The second argument may be the static arg2 (viz_fmore) */
    if(arg2) arg3 = t, t = arg2;
    else arg3 = (char *)0 ;
    if (*t != '{' /*}*/) {
	fprintf(stderr, "++++Second argument missing for %s{%s}\n",
	  macro_name, bName.buf) ;
	return((char *)0) ;
    }
    BUF_Clear(&bCollect) ;
    append_names(&bCollect, t) ;
    if ((!loc) && bCollect.used) {	/* CATALOG with column names ! */
	fprintf(stderr, "++++COLUMN(s) and no TABLE(s) for %s\n", macro_name) ;
	return(loc) ;
    }
    if (loc) loc = bCollect.buf ;
    t += strloc(t, /*'{'*/ '}') ;
    if (!arg3) arg3 = t ;		/* Save it for finding 3rd argument */
    return(loc) ;
}

static int act_cols(table, colexpr, action)
/*++++++++++++++++
.PURPOSE  Give a table and a list of columns (that may use regular expressions)
	  execute the specified action.
.RETURNS  Number of columns on which the action was applied
.REMARKS  The action is a function(COLINFO *col) and must return 0 or 1.
	colexpr is assumed to be STRIPPED. (no heading/leading blank)
-----------------*/
  TABINFO *table;	/* IN: the table concerned 	*/
  char *colexpr;	/* IN: List of columns (since V2.7: expression) */
  int (*action)();	/* IN: Callback function (COLINFO) */
{
  COLINFO *pf, *ef;
  int i, matching=0, allbut=0, colno, count=0;
  char x, *c, *ccol;

    ef = table->afmt + table->nfmt;
    c = colexpr;
    /* ccol is an array which indicates the columns concerned */
    ccol = malloc(table->nfmt);

    if (isalnum(c[0]) && (c[1] == '_') && (c[2] == '*')) 
	matching |= 1;	/* e.g. e_* = all errors */
    if (*c == '-') { 	/* No column can start by - ... */
	allbut = 1;
	c++;
    }
    if (*c == '*') {	/* Pattern matching */
	matching |= 1;
	c++;
    }
    memset(ccol, allbut, table->nfmt);

    while (*c) {
#if 0
	if (*c == '*') {	/* From here:  Expression */
	    matching |= 1;
	    c++;
	}
#endif
	i = strloc(c, '\t');
	if (i == 0) { c++; continue; }
	x = c[i]; c[i] = 0;
	if (matching&1) 	/* Regular Expression */
	for (pf=table->afmt; pf<ef; pf++) {
	    if (!strmatch(c, pf->label)) continue;
	    colno = pf - table->afmt;
	    if (allbut) ccol[colno] &= ~1;
	    else ccol[colno] |= 1;
	}
	else if ((pf = tbf_findlabel(table, c))) {
	    colno = pf - table->afmt;
	    if (allbut) ccol[colno] &= ~1;
	    else ccol[colno] |= 1;
	}
        else nerrs++, fprintf(stderr,
             "++++Unknown Column '%s' in %s\n", c, macro_name);
        if ((c[i] = x)) i++;
	c += i;
    }

    /* The array ccol is now set to non-zero for fomumns concerned. */
    for (pf=table->afmt, i=0; pf<ef; pf++, i++) {
	if (ccol[i] == 0) continue;
	count += action(pf);
    }
    free(ccol);
    return(count);
}

static int setflag_anding;
static int setflag_oring;
static int setflag(COLINFO *col)
/*++++++++++++++++
.PURPOSE  Action called by act_cols: clear + set flag
.RETURNS  1
.REMARKS  Callback function of  act_cols
-----------------*/
{
    col->flags &= setflag_anding;
    col->flags |= setflag_oring;
    return(1);
}

static int viz_setflag(cad, macro, flags, value, clear)
/*++++++++++++++++
.PURPOSE  Interpret a macro \macro{tables}{cols}, and set/clear the COLINFO
	    flag for all concerned columns.
.RETURNS  Number of COLINFO flags changed
.REMARKS  macro_name assumed to be set...
	Definition of Columns:
	*   ==> From here, wildchar allowed
	-   ==> From here, all BUT
	-*  ==> From here, all BUT wildchar allowed
	*-  ==> (same as -*)
-----------------*/
  CATINFO *cad;		/* IN: The ReadMe block		*/
  char *macro ;		/* IN: Macro Name 		*/
  char *flags ;		/* MOD: |1 (FILES) |2 (TABLES)  */
  int value ;		/* IN: Value to or in flags	*/
  int clear ;		/* IN: Value to clear before set*/
{
  char *t;
  int j, m ;
  TABINFO *tabf ;

    m = 0 ;
    macro_name = macro ;
    for (t = cad->more; *t; t++) {
    	t += next(t, macro_name);
    	if (! *t) break;
	if (! viz2(cad, t, flags)) continue ;
	/* "flags" is set to 1 for FILES concerned, to 2 for TABLES */
	for (j=0, tabf=cad->atinfo; j < cad->ntinfo; j++, tabf++) {
	    if (!(flags[j]&2)) continue ;
	    /* flags[j] &= ~2 ; -- DO NOT REMOVE this flag, used in viz_set */
#if 0	/* Pre-V2.7 */
    	    for (c = bCollect.buf; *c; c += i) {
    	        i = strloc(c, '\t');
    	        x = c[i]; c[i] = 0;
		if ((c[0] == 0) || ((c[0] == '*') && (c[1] == 0)))
		    pf=tabf->afmt, ef=pf+tabf->nfmt ;
    	        else pf = tbf_findlabel(tabf, c), ef = pf+1 ;
		if (pf) for (; pf<ef; pf++) {
		    if (clear) pf->flags &= ~clear ;
		    m++,
		    pf->flags |= value ;
		}
    	        else nerrs++, fprintf(stderr,
    	    	    "++++Unknown Column '%s' in %s\n", c, macro_name);
    	        if (c[i] = x) c++;
	    }
#elif 0	/* V2.7 -- changed to act_cols */
	    matching = 0;	/* Default: exact names */
	    anding = ~clear; oring = value;
	    ef = tabf->afmt + tabf->nfmt;
	    c = bCollect.buf;
	    if ((*c == '-') || ((*c == '*') && (c[1] == 0))) {	/* ALL BUT */
		for (pf=tabf->afmt; pf<ef; pf++) {
		    pf->flags &= anding;
		    pf->flags |=  oring;
		    m++;
		}
		c++;
		anding = ~value;
		oring = 0;
	    }
	    while (*c) {
		if (*c == '*') {	/* Regular Expression */
		    matching ^= 1;
		    c++;
		}
		i = strloc(c, '\t');
		if (i == 0) { c++; continue; }
		x = c[i]; c[i] = 0;
		if (matching&1) 	/* Regular Expression */
		for (pf=tabf->afmt; pf<ef; pf++) {
		    if (!strmatch(c, pf->label)) continue;
		    pf->flags &= anding;
		    pf->flags |=  oring;
		    if (oring) m++;
		}
		else if (pf = tbf_findlabel(tabf, c)) {
		    pf->flags &= anding;
		    pf->flags |=  oring;
		    if (oring) m++;
		}
    	        else nerrs++, fprintf(stderr,
    	    	    "++++Unknown Column '%s' in %s\n", c, macro_name);
    	        if (c[i] = x) i++;
		c += i;
	    }
#else	/* Use act_cols */
	    setflag_anding = ~clear;
	    setflag_oring  = value;
	    m += act_cols(tabf, bCollect.buf, setflag);
#endif
	}
    }
    return(m) ;
}

static int set_mpos(T, pos)
/*++++++++++++++++
.PURPOSE  Choose the MPOS Column
.RETURNS  0 (no MPOS column) / 1
-----------------*/
  TABINFO *T;	/* IN: Table concerned	*/
  char *pos;	/* IN: New list of Main Position [8] */
{
  COLINFO *pf;
  int i;

    /* If posfmt is specified, update the List */
    if (pos) 	/* When pos == "", the MPOS flags are removed -- good ! */
	i = tbf_mpos(T, pos);

    /* RECOMPUTE the MPOS column if it is flagged as NODB ! */
    else {
        i = T->posfmt[0] ;
        if (i>=0) {
	    pf = T->afmt + i;	/* First component of Position */
	    if (pf->flags&F_NODB) tbf_mpos(T,0) ;
        }
        i = T->posfmt[0] ;
    }

    /* V2.6: also change epoch/equinox iof associated FILES */
    if (theCat) { FILINFO *af, *ef;
	for (af=theCat->afinfo, ef=af+theCat->nfinfo; af<ef; af++) {
	    if (af->tabform != T) continue;
	    if (af->equinox) free(af->equinox); af->equinox = (char *)0;
	    if (af->epoch  ) free(af->epoch  ); af->epoch   = (char *)0;
	    if (T->equinox) af->equinox = strdup(T->equinox);
	    if (T->epoch  ) af->epoch   = strdup(T->epoch  );
	}
    }
    return(i>=0) ;
}

static int def_columns(T, maxlen, maxcols, nposcol)
/*++++++++++++++++
.PURPOSE  Choose the default columns
.RETURNS  Number of columns
-----------------*/
  TABINFO *T;	/* IN: Table concerned	*/
  int maxlen;	/* IN: Maximal lrecl	*/
  int maxcols;	/* IN: Maximal number of allowed columns */
  int nposcol ;	/* IN: How many extra columns with position */
{
  COLINFO *pf;
  int i, len, nf;

    set_mpos(T, (char *)0) ;

    /* If no column for position, set  = 0 */
    if (T->posfmt[0] < 0) nposcol = 0 ;
    while (nposcol > 0) {
	maxcols -= 2 ;
	maxlen  -= 2 ;
	for (i=0; T->posfmt[i] >= 0 ; i++) {
	    pf = T->afmt + T->posfmt[i];
	    len = pf->len; if (len>4) len=4;
	    maxlen -= len ;
	}
	nposcol-- ;
    }
    if (maxcols < 1) maxcols = 1 ;
    if (maxlen < 20) maxlen = 20 ;

    /* Loop in the fields, and add fields until
  	   we have a maximum of length and columns
    */
    for (nf=0, i=T->nfmt, len = 0, pf = T->afmt;
    	(i>0) && (nf<maxcols) && (len < maxlen); pf++, i-- ) {
	if (pf->flags & F_NODB) continue;
    	pf->flags |= F_DISP;
    	len += pf->len;
    	if (pf->flags & F_MPOS)   ;
    	else nf++, len+=2;		/* 2 bytes for separator */
    }
    while (--i >= 0) {
    	if (pf->flags & F_MPOS)   pf->flags |= F_DISP, len += pf->len +1;
	pf++;
    }
    return(nf);
}

static void set_Xcount(COLINFO *col, char *link, char *text, char *readme, 
	    int count_min)
/*++++++++++++++++
.PURPOSE  Set a column as a count to another table (vizAdddXcount)
.RETURNS  0
.REMARKS  On input, col->value contains the condition, e.g. "otherTable rs=..."
         On output, col->value contains "0" (default value of the count).
    Special cases:
    * the explanation (col->text) is added if necessary (if blank)
    * if the condition is "= ..." (self-count) the condition "ifnum..>0"
                                  is replaced by "ifnum..>1"
    * the table may be replaced by "*FK=..", => the condition is @{===$FK}
-----------------*/
{
  char *p=0, *l, *v, *m;
  int len=sizeof(link);	/* strlen("\vMore{-source=   \&-c.  }{${}}") */
  int vlen=0, clen, out_max;

    len = strlen(link)+1;
    clen = strloc(readme, ' ');		/* Length of catalog name */
    if(readme[--clen] != '/') clen++;
    col->ff = 'I'; col->len = 3;
    /* V3.25: possible diffent col->len values: col->more mau contain fmt= */
    if(col->more && (p=strstr(col->more, "fmt="))) { 
	if (isdigit(p[4])) col->len = atoi(p+4);
    }
    /* V3.15: other possible parameters */
    v = col->value;
    while ((v=strchr(v, ' '))) { len++; v++; }
    /* Add the link in col->more */
    if ((v = strstr(col->text, "\\use{")))  {
	vlen = strloc(v, '}'); v += 5;
	len += vlen;
    }
    m = col->more = malloc(len+120/*catname+corr=...*/+strlen(col->value)
	                   + col->len) ;
    strcpy(m, link);
    l = strstr(link, "vMore");
    if (v) {	/* Another macro which replaces the default '\vMore' */
	for (m=strstr(m, "vMore"); *v && (*v != '}'); m++) *m = *(v++);
	strcpy(m, strchr(l, '{'));
	v -= vlen;	/* Remove the 'use' from macro */
	vlen++;		/* Includes the terminating '}' */
	while (v[vlen]) { v[0] = v[vlen]; v++; }
	*v = 0;
    }
    m = strstr(m, "\\&");
    /* Target table: add the catalog name if necessary */
    v = col->value;	/* Mey be:
	 table(s)  condition
	 =         condition (self-count)
	 *FK=name  condition (tables specified by FK) */
    if ((*v == '=') || ((*v == '*')&&(!isalpha(v[1])))) {	/* self-count */
	if (count_min==0) count_min=1;
	strcpy(m, "${$tab}"); m += strlen(m);
	v++;
    }
    else {
        for(p=v; isgraph(*p) && (*p != '/') && (*p != '='); p++) ;
	if (*p != '/') {	/* Catalog not specified => add the catalog */
	    strncpy(m, readme, clen); m += clen;  /* Add name of catalog */
	    *(m++) = '/';
	}
	if (*p == '=') {	/*  Condition  e.g. PK=name */
	    if (*v == '*') v++;
	    *(m++) = '\\'; *(m++) = '&';
	    strcpy(m, "-corr="); m += strlen(m);
	    while (isalnum(*v)) *(m++) = *(v++); 
	    *(m++) = '='; while (*v == '=') v++;
	    while (isgraph(*v)) *(m++) = *(v++); 
	}
	else {			/* A table is there... */
	    for(v=col->value; isgraph(*v); ) *(m++) = *(v++);
	}
    }
    while (isspace(*v)) v++;	/* Skip target tables, now v -> rs=1.5 */
    
    if (count_min>0) {	/* Replace the condition */
	if ((p = strstr(col->more, ">0"))) p[1] |= count_min;
    }

    /* Locate the argument to copy in link, e.g.  rs=1.5 */

    out_max = 0;
    for (l=strstr(link, "\\&"); *l; l++) { 
	if (*l == '\1') break; 	/* Here the extra parameter is to add */
	/* V3.25: change the -out.mex value */
	if(strncmp(l, "&-out.max=9", 11) == 0) out_max = col->len;
	else if (out_max && (*l == '9')) {
	    while(l[1] == '9') l++;
	    while(--out_max>0) *(m++) = '9';
	}
	*(m++) = *l; 
    }
    /* Copy the argument */
    if (isgraph(*v)) while (isgraph(*v)) *(m++) = *(v++) ; /* Copy radius */
    else if (p && (*p == '=')) { /* Case p=> "=name" (case FK=name) */
	*(m++) = '$'; *(m++) = '{';
	v = p; while (isgraph(*v)) *(m++) = *(v++) ;	/* Copy the condition */
	*(m++) = '}';
    }

    /* V3.15: Additional parameters */
    while (*v == ' ') v++;
    while (isgraph(*v)) {
	*(m++) = '\\'; *(m++) = '&';
	while (isgraph(*v)) *(m++) = *(v++) ;
	while (*v == ' ') v++;
    }	/* End of  V3.15 additions */
    for (++l; *l; l++) *(m++) = *l; 
    *m = 0;

    /* Write the default explanation */
    if (strlen(col->text) < 6) {
	if (col->flags&F_Atext) free(col->text);
	col->text = m = malloc(strlen(text)+strlen(col->value)+5);
	strcpy(m, text); m += strlen(m);
	for (v=col->value; isgraph(*v); v++) *(m++) = *v;
	*(m++) = ' '; *(m++) = '('; while (isspace(*v)) v++; 
	while (isgraph(*v)) *(m++) = *(v++);
	*(m++) = ')'; *m = 0;
    }

    /* Rewrite the value: is 0 */
    strcpy(col->value, "0");
}

static char *load_values(char *input_file, char *datafile, int comchar, 
	int *maxlen_values)
/*++++++++++++++++
.PURPOSE  Copy values from a file (may be executable) -- remove comments
.RETURNS  The set of values, separated by \n
.REMARKS  Executable file --> Executed.
	Commented lines must have # or % or . in COLUMN 1.
	Empty lines are replaced by a single blank.
  --> maxlen_values is set to the longest word.
-----------------*/
#if TEST    /* V3.21: don't load the values when in main program */
{
    fprintf(stderr, "#...values(%s) not loaded\n", input_file);
    return(strdup(""));
}
#else
{
  static char envTab[32] = "theTab=";
  static char envFil[32] = "theFile=";
  BUFFER *b;
  char buf[BUFSIZ];
  struct stat sbuf;
  FILE *ifile ;
  int i;
  char *s;

    /* If input_file contains blank(s) ==> It's a command! */
    /* Define the current table */
    strncpy(envTab+7, datafile, sizeof(envTab)-8); putenv(envTab);
    strncpy(envFil+8, datafile, sizeof(envFil)-9); putenv(envFil);
    while (isspace(*input_file)) input_file++;
    if (strchr(input_file, ' ')) {
	/* Start by a pipe ==> use datafile */
	if (*input_file == '|') {
	    s = strdup3("fcat ", datafile, input_file);
	    ifile = popen(s, "r");
	    free(s);
	}
	else ifile = popen(input_file, "r");
    }
    else {
        sbuf.st_mode = 0;
	/* V2.86: Accept *.ext */
	if (input_file[0] == '*') {	/* Replace by name */
	    strncpy(buf, datafile, sizeof(buf));
	    strcpy(buf+strloc(buf, '.'), input_file+1);
	    input_file = buf;
	}
        if ((stat(input_file, &sbuf) == 0) && (sbuf.st_mode&0100)) {
	    /* EXECUTABLE file, open it in a pipe */
	    ifile = popen(input_file, "r");
        }
        else ifile = fzopen(input_file) ;
    }
    if (!ifile) {
	fprintf(stderr, "****") ;
	perror(input_file);
	return((char *)0);
    }
    b = BUF_New(char, BUFSIZ, BUFSIZ);
    *maxlen_values = 0;
    while(fgets(buf, sizeof(buf), ifile)) {
	if ((buf[0] == '#') || (buf[0] == '%') || (buf[0] == '.')
          ||(buf[0] == comchar)) continue;
	buf[strloc(buf, comchar)] = 0;  /* V2.98: accept comment char */
	for (s=buf+strlen(buf)-1; (s>=buf) && isspace(*s); s--) ;
	++s;
	if (s == buf) *(s++) = ' ';
	*s = 0;
	i = (s-buf);
	if (i > *maxlen_values) *maxlen_values = i;
	BUF_AppendString(b, buf); BUF_AppendString(b, "\n");
    }
    if (sbuf.st_mode&0100) pclose(ifile);	/* A pipe... */
    else fclose(ifile) ;
    s = b->buf;
    free(b);
    return(s);
}
#endif

static int add_columns(CATINFO *readme, char *macro, int flags, int *err)
/*++++++++++++++++
.PURPOSE  Add the "constant columns" marked by \vizAddColumn
.RETURNS  Number of allocated columns. flags indicate additional flags.
.REMARKS  \vizAddColumn{ tables }{ Name }{ Value }{ Unit }{ Order }{ explain }
	flags&F_USER ==> add \37_counter
	err increased in case of err
-----------------*/
{
  static char *macro_count[] = { "\\vizAddXcount", "\\vizAddCount", 
      /*"\\vizAddFKcount",*/ 0 };
  static char *link[] = { /* \1 indicates the position of argument */
    "\\ignore{X}\\ifnum{${}}>0\
\\vMore{-source=\\&-out.max=999\\&-c=${$poseq}\\&-c.\1}{${}}\
\\else{${}}\\fi", 
    "\\ignore{X}\\ifnum{${}}>0\
\\vMore{-source=\\&-out.max=999\\&\1}{${}}\
\\else{${}}\\fi", 
/*  "\\ignore{X}\\ifnum{${}}>0\
\\vMore{-source=\\&-out.max=999\\&\1}{${}}\
\\else{${}}\\fi", */
  0} ;
  static char *text[] = {
      "\\ucd{NUMBER}Count of cross-matches with table ",
      "\\ucd{NUMBER}Count of matches with table ", 
      "\\ucd{NUMBER}Count of matches with table ", 
  0};
  static char envCol[32] = "theCol=";
  struct more_alternatives *alt = 0, *palt;
  FILINFO *pf, *ef ;
  COLINFO *acol;
  char *alink, *elink, *more;
  char *a[5], *e[5], *u, x[5];	/* name , value , unit, order , explain */
  char *values, comchar=0;	/* if value starts by '.' (values from file) */
  char *p, colunit[32];
  int i;
  int n = 0;

    /* argid is an identifier of the macro which is appended to its content.
     * It is used essentially with the macro \vizAddColumn, to identify the
     * columns entered from the same \vizAddColumn. This appendix is
     * removed before the actual column creation.
     */
    argid[0] = argid[1] = argid[2] = 0;
    if (flags&F_USER) { argid[0] = '\37'; argid[1] = '0'; flags &= ~F_USER; }
    /* viz_more return in pf->more the \vizxxxx arguments
       separated by TABs.
    */
    if (viz_fmore(readme, macro)) {
	for (pf=readme->afinfo, ef=pf+readme->nfinfo; pf<ef;pf++) {
	    if (!pf->more) continue ;
	    alink = pf->more;
	    elink = alink+strlen(alink)-3;
	    /* Keep the alternatives
	    palt = alt_find(alt, alink, 5, 1);
	    if (!alt) alt = palt;
	    */
	    while (alink < elink) {
	        more = 0;    /* When a[2] = "dbtype=... fmt=... dbunit=... " */
		/* Keep the alternatives */
	        palt = alt_find(alt, alink, 5, 1);
		if (!alt) alt = palt;
		if (alt) flags |= F_CSV;	/*V3.03: mark alternatives */
		for (i=0; i<5; i++) {	/* Get the 4 arguments */
		    while (*alink == ' ') alink++;
		    a[i] = alink;
		    alink += strloc(alink, '\t') ;
		    for (p=alink-1; (p>=a[i]) && (*p == ' '); p--) ;
		    e[i] = ++p;
		    if ((x[i] = *e[i])) { *e[i] = 0; alink++; }
		    else if (i<4) {
			fprintf(stderr, "#***%s{%s}{%s}... arg#%d missing!\n",
			    macro, pf->dfile, a[0], i+2);
			if(err) *err += 1;
		    }
		}
		if (strchr(a[2], '=')) { /* Contains details for vizSet */
		    more = malloc(strlen(a[2]) + 3);
		    strcpy(more, "{"); strcat(more, a[2]); strcat(more, "}");
		    if ((u = strstr(a[2], "unit="))) {
			if (u>a[2]) { 	/* Verify: don't mix with "dbunit" */
			    --u;
			    if (isgraph(*u)) u = strstr(u, " unit=");
			}
		    }
		    if (u) { 
			u += 1+strloc(u, '=');
			for (i=0; isgraph(u[i]); i++) ;
			if (i>=sizeof(colunit)) i=sizeof(colunit)-1;
			strncpy(colunit, u, i); colunit[i] = 0;
			u = colunit;
		    }
		    else colunit[0] = 0;
		    u = colunit;
		}
		else u = a[2];
		if (argid[0]) {
		    *e[4] = x[4];  e[4] = a[4] + strloc(a[4], argid[0]);
		    x[4] = *e[4]; *e[4] = 0;
		}
		/* Load the values from a File if Value starts by a '.' */
		values = (char *)0;
		if ((a[1][0] == '.') && a[1][1]) { int maxlen=0;
		    a[1] += 1;
		    if (a[1][1] && strchr(inline_comment, a[1][0])) {
		    /* V2.98: May specify in addition a character for in-line
		     *        comment. */
			comchar = a[1][0];
			a[1] += 1;
		    }
		    fprintf(stderr, "#...%s{%s}: values from file %s\n",
			    macro, a[0], a[1]);
  		    strncpy(envCol+7, a[0], sizeof(envCol)-8); putenv(envCol);
		    values = load_values(a[1], pf->dfile, comchar, &maxlen);
		    if (!values) exit(1);
		    /* Take the longest string as 'value' for tbf_addcol */
		    for (p=values; *p ; p += i+1) {
			i = strloc(p, '\n');
			if (i == maxlen) break;
		    }
		    if (maxlen) p[maxlen] = 0;
		    acol = tbf_addcol((TABINFO *)pf, -1, a[0], a[4], p, u);
		    if (maxlen) p[maxlen] = '\n';
		    if (acol) {	/* test added in V3.26 */
		        acol->elims &= ~F_CCST;
		        acol->elims |=  F_REQD; /* V3.12 */
		        acol->flags |= F_Alist;
		        if (acol->value) free(acol->value);
		        acol->value = values;
		        /* -- Already done in tbf_addcol:
		        acol->ff = 'A';
		        acol->len = maxlen;
		        */
		    }
		}
		else {	/* V2.92: take NEXT alternative */
		    p = alt_next(palt);
		    acol = tbf_addcol((TABINFO *)pf, -1, a[0], a[4],
		      a[0]+palt->offset, /* p */
		      u);
		}
		if (!acol) {
		    fprintf(stderr, "****Can't %s{%s}{%s}\n",
			macro, pf->dfile, a[0]);
		    if(err) *err += 1; /*exit(1); [Mod. V3.24] */
		    continue;	/* Added V3.26 */
		}
		/* Replace length by longest alternative length
		   (in case value=,x,y,..)
		*/
		if (acol->elims & F_CCST) {
		    if (palt->len>0) acol->value[palt->len] = 0;
		    if (palt->maxlen>0)
			acol->len = palt->maxlen;
		}
		acol->flags |= flags;
		acol->more = more;
		/* V2.99: F_ZERO => vizAddXcount, counter column */
		if (acol->flags&F_ZERO) { int i; char *b; 
		    /* Mod. V3.19: a[1] contains list of table + rs */
		    for (i=0; macro_count[i]; i++) {
			if (strcmp(macro_count[i], macro)==0) break;
		    }
		    /* AddCount requires at least 2 matches (\ifnum >1)
		     * when the table is included among target tables (V3.18) */
		    if ((b = strchr(a[1], ' '))) *b = 0; /* Added V3.19 */
		    set_Xcount(acol, link[i], text[i], readme->fbuf, 
			    match_list(a[1], pf->dfile)>0);
		    acol->flags &= ~F_ZERO;
		    if (b) *b = ' '; /* Added V3.19 */
		}
		if (*a[3]) tbf_order((TABINFO *)pf, a[0], a[3]);
		for (i=5; --i>=0; )  	/* Reset the 4 arguments */
		    *e[i] = x[i];
		n++;
	    }
	    free(pf->more); pf->more = (char *)0;
	}
    }
    argid[0] = argid[1] = 0;
    alt_free(alt);
    return(n) ;
}

static int add_param(CATINFO *readme, char *macro, int flags, int *err)
/*++++++++++++++++
.PURPOSE  Add the "constant columns" marked by \vizParam
.RETURNS  Number of allocated columns
.REMARKS  \vizParam{ tables }{ Name }{ Value }{ Unit }{ group }{ explain text }
	Group name saved as a Comment "GRP=name"
	err increased in case of error (V3.24)
-----------------*/
{
  FILINFO *pf, *ef ;
  COLINFO *acol;
  char *alink, *elink ;
  char *a[5];		/* name , value , unit, group , explain */
  int i;
  int n = 0;
    /* viz_more return in pf->more the \vizxxxx arguments
       separated by TABs.
    */
    if (viz_fmore(readme, macro)) {
	for (pf=readme->afinfo, ef=pf+readme->nfinfo; pf<ef;pf++) {
	    if (!pf->more) continue ;
	    alink = pf->more;
	    elink = alink+strlen(alink)-3;
	    while (alink < elink) {
		for (i=0; i<5; i++) {	/* Get the 4 arguments */
		    a[i] = alink;
		    alink += strloc(alink, '\t') ;
		    *(alink++) = 0;
		}
		acol = tbf_addcol((TABINFO *)pf, -1, a[0], a[4], a[1], a[2]);
		if (!acol) {
		    fprintf(stderr, "****Can't %s{%s}{%s}\n",
			macro, pf->dfile, a[0]);
		    if(err) *err += 1; /* [V3.24] exit(1); */
		}
		acol->signature = cad_signature("\3PAR");
		acol->oid = cad_oid();
		acol->flags |= flags;
		if (*a[3]) acol->comment = strdup2("GRP=", a[3]);
		n++;
	    }
	    free(pf->more); pf->more = (char *)0 ;
	}
    }
    return(n) ;
}

static int add_links(CATINFO *readme, char *macro, int flags, int *err)
/*++++++++++++++++
.PURPOSE  Add the "constant columns" marked by \vizLink
.RETURNS  Number of allocated columns
.REMARKS  macro = \vizLink{table}{col}{contents}{Link generation}{Explain}
                                  #0    #1           #2             #3
	The column name may be in "Explain" followed by a : (old system)
	err increased in case of error
-----------------*/
{
  char link_name[16];
  FILINFO *pf, *ef ;
  COLINFO *col;
  char *alink, *elink ;
  char *p, *a[5];	/* name , value , Link Generation , explain, order */
  int i;
  int n = 0;
    /* viz_more return in pf->more the \vizxxxx arguments
       separated by TABs.
    */
    if (viz_fmore(readme, macro)) {
	for (pf=readme->afinfo, ef=pf+readme->nfinfo; pf<ef;pf++) {
	    if (!pf->more) continue ;
	    alink = pf->more;
	    elink = alink+strlen(alink)-3;
	    while (alink < elink) {
		a[4] = 0;		/* V2.96: column order */
		for (i=0; i<4; i++) {	/* Get the 3 arguments */
		    a[i] = alink;
		    alink += strloc(alink, '\t') ;
		    if (*alink) *(alink++) = 0;
		}
		/* Take the default column name */
		while (isspace(*a[0])) a[0] += 1;
		if (! *a[0]) {		/* No name */
		    p = a[3];		/* Explain */
		    while (isspace(*p)) p++;
		    while (isgraph(*p) && (*p != ':')) p++;
		    if (*p == ':') {
			*(p++) = 0; while (isspace(*p)) p++;
			a[0] = a[3];
			a[3] = p;
		    }
		    else {
			sprintf(a[0] = link_name, "Link%d", n+1);
			if (p[1] == ':') fprintf(stderr,
				"++++%s{%s}: blank before colon(:)?\n",
				macro, a[3]);
		    }
		}
		/* V2.96: order of column */
		for (p=a[0]; isgraph(*p); p++) ; while (*p == ' ') *(p++) = 0;
		if (*p) a[4] = p; 	/* e.g. n_Col +Col */
		if (!tbf_addcol((TABINFO *)pf, -1, a[0], a[3], a[1], 0)) {
		    fprintf(stderr, "****Can't %s{%s}{%s}\n",
			macro, pf->dfile, a[0]);
		    if(err) *err += 1; 
		    break; /* [V3.24] exit(1); */
		}
		if (a[4]) tbf_order (pf->tabform, a[0], a[4]);
		if ((col = tbf_findlabel(pf->tabform, a[0]))) {
		    if (*a[2]) {			/* Link */
		        col->more = strdup(a[2]);
		        mark_link(pf, a[2], col);	/* Added V3.23 */
		    }
		    col->flags |= flags;
		    n++;
		}
		else {
		    fprintf(stderr, 
			"#***%s{%s}{ %s %s}{ %s }{...}{...} error\n",
			macro, pf->dfile, a[0], a[4] ? a[4] : "", a[1] );
		    if(err) *err += 1;
		}
	    }
	    free(pf->more); 
	    pf->more = (char *)0 ;
	}
    }
    return(n) ;
}

/*==================================================================
		External Utilities for Vizir Installation
 *==================================================================*/

char *viz_getkey(cad, key)
/*++++++++++++++++
.PURPOSE  Get from ".status" or ".Summary" the explanation
.RETURNS  List of words separated by TABs. / NULL if not defined
.REMARKS  key may be ""
-----------------*/
  CATINFO *cad;		/* IN: All loaded details	*/
  char *key;		/* IN: Key to look at, e.g. "\cUsualName"	*/
{
  char *s;

    if (! (cad->flags&CAT_more)) load_more(cad);

    BUF_Clear(collect);
    s = cad->more + next(cad->more, key);		/* Note: s->'{'	*/
    if (!*s) return ((char *)0);

    while (*s)	{		/* Loop on the occurences of key	*/
    	s += append_names(collect, s);			/* Note: } over	*/
    	s += next(s, key);
    }
    return(collect->buf);
}

char *viz_getmac(cad, key)
/*++++++++++++++++
.PURPOSE  Get from ".status" or ".Summary" all details of a macro,
	as a table (tab-separated line with arguments, lines terminated with \v)
.RETURNS  TAB-separated arguemnts of macro.
.REMARKS  No \n and end of last row
-----------------*/
  CATINFO *cad;		/* IN: All loaded details	*/
  char *key;		/* IN: Key to look at, e.g. "\cUsualName"	*/
{
  char *s, x;
  int i, len;

    if (! (cad->flags&CAT_more)) load_more(cad);

    BUF_Clear(collect);
    s = cad->more + next(cad->more, key);		/* Note s->'{'}	*/
    if (!*s) return ((char *)0);

    while (*s)	{		/* Loop on the occurences of key	*/
	if (collect->used) BUF_AppendString(collect, "\v") ;
	for (i=0; *s == '{' /*}*/; i++) {
	    if (i) BUF_AppendString(collect, "\t") ;
	    len = strbrace(s) ;
	    x = s[len]; s[len] = 0 ;
	    BUF_AppendString(collect, s+1) ;
	    s += len ;
	    if (x) *(s++) = x ;
	    while (isspace(*s)) s++ ;
	}
    	s += next(s, key);
    }
    return(collect->buf);
}

char *cad_keywords(cad, keyword_type)
/*++++++++++++++++
.PURPOSE  Get Keywords from a loaded catalogue
.RETURNS  List of keywords separated by TABs.
.REMARKS  keyword_type may be "ADC", "", "WL",
		"Mission"
	 We first look for \vizKeyword{type}{key key key}
	 If nothing, we look in ReadMe
-----------------*/
  CATINFO *cad;		/* IN: All loaded details	*/
  char *keyword_type;	/* IN: Key to look at, e.g. "ADC_Keyword", Mission*/
{
  SECTION *sec; int i;
  char *p, *s, buf[40];

    if (! (cad->flags&CAT_more)) load_more(cad);
    BUF_Clear(collect);

    if (cad->more) {	/* Look for \\viz' macros */
	strcpy(buf, "\\vizKeyword{"); p = buf + strlen(buf);
	i = strlen(keyword_type);
	if (i > sizeof(buf)-20) i = sizeof(buf)-20;
	strncpy(p, keyword_type, i);
	p[i++] = '}'; p[i] = 0;
	viz_getkey(cad,buf);
    }

    /* If the keyword is found, just ignore the ReadMe contents */
    if (bCollect.used) return(bCollect.buf);

    /* Prepare the Keyword to look at 	*/
    buf[sizeof(buf)-20] = 0;
    strncpy(buf, keyword_type, sizeof(buf)-20);
    if (*buf) strcat(buf, "_");

    /* Loop over section, find the _Keyword: ones */
    for (sec = cad->section[0]; sec; sec = sec->next) {
	if (sec->class != SEC_Keywords) continue;
	if (strncmp(sec->header, buf, strlen(buf))) continue;
	p = sec->header + strloc(sec->header, ':');
	if (*p == ':') p++;
	if (bCollect.used) BUF_AppendString(&bCollect, " ; ");
	BUF_AppendString(&bCollect, p);
	if ((sec->abody < sec->ebody) && (sec->abody[0] != '\n'))
	    BUF_AppendString(&bCollect, sec->abody);
    }
    if (bCollect.used == 0) return((char *)0);

    /* Reformat the Keywords:
        WL_Keyword: a simple list, similar to Column Names (no blank)
       ADC_Keyword: the - separates the text from numeric key value
                    (ignore the numeric part); separator is ;
        Other keyw: - or ; as delimiters
    */
    if ((strcmp(buf, "WL_") == 0) || (strcmp(buf, "Mission") == 0)) {
    	BUF_Clear(&bName);
    	append_names(&bName, bCollect.buf);
    	return(bName.buf);
    }

    i = 1;	/* Here, i is state 0 (ignore), 1 (in Keyword) */
    p = s = bCollect.buf;
    while (*s) {
    	while (isspace(*s)) s++;
    	if (*s == ';') { *(p++) = '\t'; s++; i = 1; continue; }
    	if (*s == '-') {
    	    while (*s == '-') s++;
	    while (isspace(*s)) s++; 
    	    if (strncmp(buf, "ADC", 3) == 0) {	/* ADC_Keyword ignore number */
		if (isdigit(*s)) i = 0;
		else *(p++) = '\t';
    	    	continue;
    	    }
    	    *(p++) = '\t';
    	    continue;
    	}
	if ((p > bCollect.buf) && isGraph(p[-1])) *(p++) = ' ';
    	while (isGraph(*s) && (*s != ';')) *p = *(s++), p += i;
    }
    while ((p > bCollect.buf) && isspace(p[-1])) p--;
    *p = 0;

    return(bCollect.buf);
}

/*==================================================================*/
static void set_atext(char **astring, int *aflag, char *arg3, int opt)
/*++++++++++++++++
.PURPOSE  Replace or Appends the Text
.RETURNS  ---
.REMARKS  arg3 starts by + --> APPEND
	argid is appended
-----------------*/
  /* char **astring 	= IN: Where to store the copy's pointer  */
  /* int  *aflag:	IN: Flag to change with F_Atext (new allocation) */
  /* char *arg3 :	IN: Text to replace/append             */
  /* int opt: 		IN: what to do if a string already exists:
   * 	0=don't do anything if string already exists;
   * 	1=replace if exists
   * 	2=append, separator "\t" unless arg3 starts by '+'
   * 	3=replace, or append (no separator) if arg3 starts by '+'
   **/
{
  static BUFFER *bMore ;
  char *a, *otext, sep, buf[20];
  int pos, replace_plus;

    if (!bMore) bMore = BUF_Open(char, 256, 256) ;
    BUF_Clear(bMore) ;
    BUF_AppendString(bMore, "");

    otext = *astring;		/* Original Text */
    if (otext && (opt == 0))	/* Text already exists... */
	return;

    if (otext && (opt&2)) { 	/* Append text ... */
	BUF_AppendString(bMore, otext);
    }
    if (aflag) {	/* text string: replacement, flag */
	if (*aflag & F_Atext) free(*astring);
	*aflag |= F_Atext ;
    }
    else if (*astring) {
	free (*astring) ;
    }
    *astring = (char *)0 ;

    /* Append All Remaining Arguments, replacing {} by \tabs */
    a = arg3 ;
    if ((opt == 2) && bMore->used) sep = '\t';
    else sep = 0;
    while (*a == '{' /*'}'*/) {
	replace_plus = -1;
	if (opt == 3) { 	/* Append or replace ?  */
	    if (a[1] == '+')
		 replace_plus = bMore->used;
	    else BUF_Clear(bMore);
	    opt = 2;
	    pos = strNote(bMore->buf);
	    if ((pos > 0) && bMore->used) {	 /* It's a note ! */
		/* In a note: write the note number at the end... */
		--pos;		/* Index of '('  */
		if ((pos>0) && isspace(bMore->buf[pos-1])) --pos;
		bMore->used = pos;
		strncpy(buf, bMore->buf+bMore->used, sizeof(buf));
		buf[sizeof(buf)-1] = 0;
		bMore->buf[bMore->used] = 0;
		if (replace_plus>=0) replace_plus = bMore->used;
	    }
	    else buf[0] = 0;
	    pos = bMore->used;
	    a += append_arg(bMore, a);
	    BUF_AppendString(bMore, buf);	/* Add the Note Number */
	    if (replace_plus>=0) bMore->buf[replace_plus] = ' ';
	}
	else {
	    if (sep) BUF_AppendItem(bMore, char, &sep);
	    a += append_arg(bMore, a);
	}
	while (isspace(*a)) a++ ;
	sep = '\t' ;
    }
    if (argid[0]) BUF_AppendString(bMore, argid);
    *astring = (char *)strdup(bMore->buf) ;
}

static int setmore_which_string;
static int setmore_opt = 3;  /* Option to replace/append, see set_atext() */
static int setmore(COLINFO *col)
/*++++++++++++++++
.PURPOSE  Action called by act_cols: insert the "text", "more" or "comment"
.RETURNS  1
.REMARKS  Callback function of  act_cols
-----------------*/
{
  char **a, *atext;
  int *aflag;
    a = &(col->text) + setmore_which_string ;
    atext = arg3 ;
    if (setmore_which_string == 0) {	/* Replace Explanation */
	aflag = &(col->flags) ;
    }
    else aflag = (int *)0 ;
    set_atext(a, aflag, atext, setmore_opt);
    return(1);
}


static int set_more(CATINFO *cad, char *macro, int which_string, int opt, int *err)
/*++++++++++++++++
.PURPOSE  Get into the "text", "more" or "comment"
	string the explanation from
	\\macro{ table(s) } { field(s) } { Contents }
.RETURNS  Number of columns OR files OR catalog with filled macro
	(err increased in case of err)r -- V3.24
Arguments:
  (IN) cad          :  All loaded details
  (IN) macro        :  macro name
  (IN) which_string :  0=text, 1=more, 2=comment
  (IN) opt          :  0=ignore if exists, 1=replace, 2=append, 3=append+
------------------*/
{
  TABINFO *pt;
  FILINFO *pf, *ef ;
  char *t, *c, *loc, **a, *flags, *atext ;
  int j, k, m, *aflag ;

    m = 0 ;
    macro_name = macro ;
    setmore_which_string = which_string;
    /* setmore_opt = 3; */
    /* Keep files/tables concerned in an array of flags */
    flags = (char *)malloc(cad->nfinfo) ;
    for (t = cad->more; *t; t++) {
    	t += next(t, macro_name);
	if (argid[0]) { /* Increment -- argtid on 2 bytes */
	    argid[1] += 1; 
	    if (argid[1] == 0) { 
		argid[1] = '0'; 
		argid[2] += 1; 
		if ((argid[2]&0xff) < '0') argid[2] = '0';
	    }
	}
    	if (! *t) break;
	arg3 = 0; /* V3.16 */
	loc = viz2(cad, t, flags) ;		/* loc is NULL for CATALOG */
	if (!arg3)   /* viz2 FAILED */ continue ;

    	if (*arg3 == /*{*/ '}' ) arg3++;
    	while (isspace(*arg3)) arg3++;
    	if (*arg3 != '{' /*}*/ ) {
    	    fprintf(stderr, "#***%s{...}{...} third argument missing!\n", 
		    macro_name) ;
	    if(err) *err += 1;
    	    continue ;
    	}

	if (!loc) {	/* Comment for a CATALOG */
#if 0
	    /* a = which_string == 1 ? &(cad->more) : &(cad->comment) ; */
	    a = &(cad->comment) ;
	    set_atext(a, (int *)0, arg3, opt);
#else
            if (which_string == 0) {  
                /* change the title when \vizExplain is Set */
                char *p = strdup(cad->section[0]->abody);
                char *ptr = p;
                while (isgraph(*ptr)) ptr++ ;
                if (*ptr) *ptr = '\0';
                a = &p;
                set_atext(a, (int *)0, arg3, 2);
                cad->section[0]->abody = p;
            }
            else {
                a = &(cad->comment) ;
                set_atext(a, (int *)0, arg3, opt);
            }

#endif
	    m++;    /* m = -1; -- V2.5 */
	    continue ;
	}

	/* k is a counter of number of found columns */
	for (j=k=0, pt=cad->atinfo; j < cad->ntinfo; j++, pt++) {
	    if (!(flags[j]&2)) continue ;
	    c = bCollect.buf ;
	    if (!*c) {			/* more applies to File */
		for (pf=cad->afinfo, ef=pf+cad->nfinfo; pf < ef; pf++) {
		    if (pf->tabform != pt) continue ;
		    a = &(pf->text) + which_string ;
		    atext = arg3 ;
		    if (which_string == 0) {	/* Replace Explanation */
			aflag = &(pf->flags) ;
			/* Must remove the note ... done in set_atext
			if (*atext == '*') atext++ ;
			else pf->note = (SECTION *)0 ;
			 */
		    }
		    else aflag = (int *)0 ;
		    set_atext(a, aflag, atext, opt);
		    /* k = -2 ;	-- V2.5: -2 means Match File(s) */
		    k++;	/* V2.51 */
		}
	    }
    	    else
#if 0	/* Prev-V2.7 */
	    for ( ; *c; c += i) {	/* more applies to columns */
    	        i = strloc(c, '\t');
    	        x = c[i]; c[i] = 0;
    	        if (pc = tbf_findlabel(pt, c)) {
		    k++ ;
		    a = &(pc->text) + which_string ;
		    atext = arg3 ;
		    if (which_string == 0) {	/* Replace Explanation */
			aflag = &(pc->flags) ;
		    }
		    else aflag = (int *)0 ;
		    set_atext(a, aflag, atext) ;
	        }
    	        else nerrs++, fprintf(stderr,
    	    	    "++++Unknown Column '%s' for %s\n", c, macro_name);
    	        if (c[i] = x) c++;
    	    }
#else	/* use act_cols */
	    {   /* Mod. V2.97 */
		int old_setmore_opt = setmore_opt;
		setmore_opt = opt;
	        k += act_cols(pt, bCollect.buf, setmore);
		mark_link(pt, bCollect.buf, 0);	/* V3.23 added */
		setmore_opt = old_setmore_opt; 
	    }
#endif
    	}
	if (k == 0) {
	    fprintf(stderr, "****Macro '%s' doesn't match any table\n",
		macro_name) ;
	    if(err) *err += 1;
	}
	m += k ;
    }
    free(flags) ;
    return(m) ;
}

int viz_addmore(cad, text)
/*++++++++++++++++
.PURPOSE  Add new (user-supplied) definitions in the "more" (.status) text
.RETURNS  0 / -1
-----------------*/
  CATINFO *cad;		/* MOD: All loaded details		*/
  char *text;		/* IN: Text to add to the .status	*/
{
  char *new, *p ;
  int n = 0 ;

    if (!text) return(0) ;
    if (!*text) return(0) ;
    if (! (cad->flags&CAT_more)) load_more(cad);
    if (cad->more) n = strlen(cad->more) ;
    if (text) n += strlen(text) ;
    if (n == 0) return(0) ;
    new = p = (char *)malloc(n+3) ;
    if (cad->more) {
	strcpy(p, cad->more) ; p += strlen(p) ;
	free(cad->more) ;
	cad->more = (char *)0 ;
    }
    *(p++) = '\n' ;
    strcpy(p, text) ; p += strlen(p) ;
    *(p++) = '\n' ;
    *p = 0 ;
    cad->more = new ;
    return(0) ;
}

int viz_errors()
/*++++++++++++++++
.PURPOSE  Get the Number of Errors in last viz_more / viz_macro
.RETURNS  Number of errors
-----------------*/
{
  int n ;
    n = nerrs ; nerrs = 0 ;
    return(n) ;
}

int viz_more3(cad, macro, opt)
/*++++++++++++++++
.PURPOSE  Get into the "more" string the explanation from
	\\macro{ table(s) } { field(s) } { Contents }
.RETURNS  Number of columns/tables with filled macro
	-1 if macro concerns CATALOG
.REMARKS  NULL macro ==> Free all allocated MORE elements
	(except when the static "keep_allocated_more&1" is set)
	Number of errors can be retrieved via viz_errors
	opt specifies what to do in case a macro already exists:
   * 0=don't do anything if string already exists;
   * 1=replace if exists
   * 2=append, separator "\t" unless arg3 starts by '+'
   * 3=replace, or append (no separator) if arg3 starts by '+'
-----------------*/
  CATINFO *cad;		/* MOD: All loaded details		*/
  char *macro;		/* IN: macro to look at, starts by \	*/
  int opt;		/* IN: option leave/replace/append...   */
{
  TABINFO *pt, *et ;
  FILINFO *pf, *ef ;
  COLINFO *pc, *ec ;
  int n = 0 ;
  char *p ;
  int i ;

    if (! (cad->flags&CAT_more)) load_more(cad);
    if (! cad->more) return(0) ;
    if (! (cad->flags&CAT_tdup)) cad_tdup(cad) ;	/* Independent fmt  */

    /* Check whether the macro is related to a FLAG
       (in  macroflags  list)
    */
    for (i=0; macroflags[i].name; i++) {
	if (strcmp(macroflags[i].name, macro) != 0) continue ;
	p = (char *)malloc(cad->nfinfo + cad->ntinfo);
	viz_setflag(cad, macroflags[i].name, p,
		macroflags[i].toset, macroflags[i].toclear) ;
	free(p) ;
    }

    /* Free all already loaded more columns */
    if (!macro) macro = "" ;
    if (!*macro) {	/* Free macros at FILE level */
        for (pf=cad->afinfo, ef=pf+cad->nfinfo; pf<ef; pt++) {
	    if (pf->more) free(pf->more), pf->more = (char *)0 ;
	}
    }

    for (pt=cad->atinfo, et=pt+cad->ntinfo; pt<et; pt++)
    for (pc=pt->afmt, ec=pc+pt->nfmt; pc<ec; pc++) {
	if (pc->more) {
    	    if (keep_allocated_more&1) continue;
	    if (!isupper(pc->ff))	n++ ;	/* Not a standard column.. */
	    else {
	        free(pc->more);
	        pc->more = (char *)0 ;
	    }
	}
    }

    if (!*macro) return(n) ;	/* Only REMOVE the macros...	*/

    return(set_more(cad, macro, 1, opt, 0));
    				/* Append if more already exists */
}

int viz_more(cad, macro)
/*++++++++++++++++
.PURPOSE  Get into the "more" string the explanation from
	\\macro{ table(s) } { field(s) } { Contents }
.RETURNS  Number of columns/tables with filled macro
-----------------*/
  CATINFO *cad;		/* MOD: All loaded details		*/
  char *macro;		/* IN: macro to look at, starts by \	*/
{
    return(viz_more3(cad, macro, 2)) ;
}

int viz_fmore(cad, macro)
/*++++++++++++++++
.PURPOSE  Get into the "more" string the explanation from
	\\macro{ table(s) } { Contents }
.RETURNS  Number of tables with filled macro
.REMARKS  NULL macro ==> Free all allocated MORE elements
	Number of errors can be retrieved via viz_errors
-----------------*/
  CATINFO *cad;		/* MOD: All loaded details		*/
  char *macro;		/* IN: macro to look at, starts by \	*/
{
  char *old_arg2 ;
  int stat ;
    old_arg2 = arg2 ;
    arg2 = "{}" ;
    stat = viz_more(cad, macro);
    arg2 = old_arg2 ;
    return(stat) ;
}

int viz_usermacro(cad, macro, value)
/*++++++++++++++++
.PURPOSE  Do the job of 1 macro:
	set the relevant columns if macro corresponds to a flag,
	or load the "more"
.RETURNS  Number of columns concerned
-----------------*/
  CATINFO *cad;		/* MOD: All loaded details		*/
  char *macro;		/* IN: macro to look at, starts by \	*/
  int value ;		/* IN: Value to set, F_USER by Default	*/
{
  char *p ;
  int n ;

    if (!value) value = F_USER ;
    if (! (cad->flags&CAT_tdup)) cad_tdup(cad) ;	/* Independent fmt  */

    p = (char *)malloc(cad->nfinfo + cad->ntinfo);
    n = viz_setflag(cad, macro, p, value, value) ;
    free(p) ;
    return(n) ;
}

int viz_macro(cad, macro)
/*++++++++++++++++
.PURPOSE  Do the job of 1 macro:
	set the relevant columns if macro corresponds to a flag,
	or load the "more"
.RETURNS  Number of columns concerned
-----------------*/
  CATINFO *cad;		/* MOD: All loaded details		*/
  char *macro;		/* IN: macro to look at, starts by \	*/
{
  int i, n ;
  char *p ;

    if (! (cad->flags&CAT_more)) load_more(cad);
    if (! cad->more) return(0) ;
    if (! (cad->flags&CAT_tdup)) cad_tdup(cad) ;	/* Independent fmt  */

    /* Check whether the macro is related to a FLAG
       (in  macroflags  list)
    */
    for (i=0; macroflags[i].name; i++) {
	if (strcmp(macroflags[i].name, macro) != 0) continue ;
	p = (char *)malloc(cad->nfinfo + cad->ntinfo);
	n = viz_setflag(cad, macroflags[i].name, p,
		macroflags[i].toset, macroflags[i].toclear) ;
	free(p) ;
	return(n) ;
    }

    /* Not a Flag. Therefore load the "more" */
    return(viz_more(cad, macro)) ;
}

int viz_load(CATINFO *cad)
/*++++++++++++++++
.PURPOSE  Load all additional data fron .status and/or .Summary:
	additional columns, links, etc...
.RETURNS  Number of additional columns added -- negative if one or more
		errors detected.
.REMARK  \vizParam{ tables }{ Name }{ Value }{ Unit }{ group }{ explain text }
	F_LINK indicates a Column which stays Constant in DB.
-----------------*/
{
  int n=0, err=0;
  int saved_keep_allocated_more;	/* 3: don't free, mark as processed */

    saved_keep_allocated_more = keep_allocated_more; keep_allocated_more = 3;
    n += add_columns(cad, "\\vizAddColumn", F_USER, &err);
    n += add_columns(cad, "\\vizAddFKflag", F_isFK|F_DISP/*|F_LINK*/, &err);
    n += add_columns(cad, "\\vizAddXcount", F_ZERO|F_DISP, &err); /* V2.99*/
    n += add_columns(cad, "\\vizAddCount",  F_ZERO|F_USER|F_DISP, &err); 
                                                                 /* V3.02*/
    /* n += add_columns(cad, "\\vizAddFKcount", 
	    F_ZERO|F_isFK|F_USER|F_DISP); -- V3.14, removed V3.17 */
    n += add_links  (cad, "\\vizLink", F_LINK, &err);
    n += add_param  (cad, "\\vizParam", 0, &err);
    keep_allocated_more = saved_keep_allocated_more;
    if(err) n=-n;
    return(n);
}

int viz_set(cad, maxlen, maxcols, nposcol)
/*++++++++++++++++
.PURPOSE  Initialize the Catalogue for AstroVizir: keep tables to save,
	define the default columns.
.RETURNS  0 (OK) / Number of Errors
-----------------*/
  CATINFO *cad;		/* MOD: All loaded details	*/
  int maxlen;		/* IN: Maximal acceptable width	*/
  int maxcols;		/* IN: Maximal number of columns*/
  int nposcol ;		/* IN: How many extra columns with position */
{
  CATINFO *oldCat;
  FILINFO **files;	/* To convert tabinfo --> filinfo */
  char *t, *c, x=0, *fflags, *tflags;
  int i, j, k, errors;
  FILINFO *file; TABINFO *tabf; COLINFO *pf, *ef;
  int matching, setall, anding;

    errors = 0 ;
    oldCat = theCat ; theCat = cad;
    if (maxlen <= 0) maxlen = 9999;
    if (maxcols <= 0) maxcols = 999;
    if (! (cad->flags&CAT_more)) load_more(cad);
    if (! (cad->flags&CAT_tdup)) cad_tdup(cad) ;	/* Independent fmt  */

    /* 0) Flag F_NODB the columns named "--" ,
       and realloc tables used for several files */
    for (tabf = cad->atinfo, i=cad->ntinfo ; --i >= 0; tabf++) {
	for (pf = tabf->afmt, j = tabf->nfmt; --j >= 0; pf++) {
	    if ((pf->label[0] == '-') && (pf->label[1] == '-'))
		pf->flags |= F_NODB ;
	    if ((pf->elims&(F_SORT|F_SRTE)) == F_SORT)
		pf->flags |= F_isPK|F_INDX ;
	}
    }

    /* An array of bytes is used to set the matching files */
    fflags = (char *)malloc(cad->nfinfo + cad->ntinfo);
    tflags = fflags + cad->nfinfo;
    memset(tflags, 0, cad->ntinfo);

    /* Build the array tabinfo --> filinfo */
    files = (FILINFO **)malloc(sizeof(FILINFO *)*cad->ntinfo);
    for (tabf=cad->atinfo, k=0; k<cad->ntinfo ; k++, tabf++) {
	files[k] = (FILINFO *)0;
	for (file=cad->afinfo, i=cad->nfinfo; --i>=0; file++) {
	    if (file->tabform == tabf) {
		files[k] = file;
		break;
	    }
	}
    }

    /* 1) Definition of Tables: insert yes/no in an array of bytes,
          one byte for each table. The default is to keep EACH table.
    */

    	/* If \vizKeepTables contains values,
    	   flag only the mentionned tables
    	*/
    memset(fflags, 1, cad->nfinfo);
    if ((t = viz_getkey(cad, "\\vizKeepTables"))) {
    	memset(fflags, 0, cad->nfinfo);
	if (set_fflags(cad, t, fflags, 1) == 0) errors++, fprintf(stderr,
	    "++++No table matching \\vizKeepTables{%s}\n", t);
    }
    	/* If \vizIgnoreTables contains values,
	   zero the mentionned tables
    	*/
    if ((t = viz_getkey(cad, "\\vizIgnoreTables"))) {
	if (set_fflags(cad, t, fflags, 0) == 0) errors++, fprintf(stderr,
	    "++++No table matching \\vizIgnoreTables{%s}\n", t) ;
    }
    	/* Remove finally the files which must NOT be kept */
    for (i=cad->nfinfo, t=fflags, file=cad->afinfo; --i>=0; file++, t++) {
    	if (*t == 0) {
	    file->flags |= F_NODB;
	    if ((tabf = file->tabform)) tabf->flags |= F_NODB;
	    /*file->tabform = (TABINFO *)0;*/
	}
    }

    /* Flag pecularities.
       The \vizIgnoreColumns is done only at the end.
    */
    for (i=1; macroflags[i].name ; i++)
	viz_setflag(cad, macroflags[i].name, fflags,
		macroflags[i].toset, macroflags[i].toclear) ;
#if 0
    viz_setflag(cad, "\\vizIndex", fflags, F_INDX, 0) ;
    viz_setflag(cad, "\\vizPK",    fflags, F_isPK, F_isFK|F_isPK) ;
    viz_setflag(cad, "\\vizFK",    fflags, F_isFK, F_isFK|F_isPK) ;
    viz_setflag(cad, "\\vizPFK",   fflags, F_isFK|F_isPK, 0) ;
    viz_setflag(cad, "\\vizCatK",  fflags, F_CATA, 0) ;	/* To another Cat. */
    viz_setflag(cad, "\\vizSimK",  fflags, F_SIMB, 0) ;	/* To Simbad.....  */
    viz_setflag(cad, "\\vizHTML",  fflags, F_HTML, F_HTML|F_TeX|F_sofTeX) ;
    viz_setflag(cad, "\\vizTeX",   fflags, F_TeX, F_HTML|F_TeX|F_sofTeX) ;
    viz_setflag(cad, "\\vizSoft",  fflags, F_sofTeX, F_HTML|F_TeX|F_sofTeX) ;
#endif

    /* Special Explanations: replace the current ones	*/
    set_more(cad, "\\vizExplain", 0, 3, &errors) ;

    /* Comments, either for Table or for Catalog	*/
    set_more(cad, "\\vizComment", 2, 3, &errors) ;

    /* We have now to flag columns useless in data-base;
       as a consequence, the definition of the POSITION columns
       may change !
    */
    /* viz_setflag(cad, "\\vizIgnoreColumns", fflags, F_NODB, 0) ; */
    i=0 ;
    if (viz_setflag(cad, macroflags[i].name, fflags,
      macroflags[i].toset, macroflags[i].toclear) > 0) {
      	for (k=0, tabf=cad->atinfo; k < cad->ntinfo; k++, tabf++) {
	    if (!(fflags[k]&2)) continue;	/* Table not concerned */
	    /* fflags[k] &= ~2; */
	    set_mpos(tabf, (char *)0);
	}
    }

    /* The MAIN POSITION can be changed by the \vizPosition macro.
       \vizPosition may exist with column names or not, e.g.
       \vizPosition{ table }{}{*vizSim}{}   (position from SIMBAD name) or
       \vizPosition{ table }{GLON GLAT}{}{} (replace the default position)
       Tables for which positions are defined are flagged by TFLAG_MPOS
    */
    macro_name = "\\vizPosition" ;
    memset(fflags, 0, cad->nfinfo);
    for (t = cad->more; *t; t++) {
    	t += next(t, macro_name);
    	if (! *t) break;
	if (! viz2(cad, t, fflags)) continue ;	/* fflags set to 2 for tables */
	flag_tabs(cad, fflags, tflags, TFLAG_MPOS) ;	/* Keep marked tables */
	/* For all tables marked, re-assign the MPOS array */
	for (k=0, tabf=cad->atinfo; k < cad->ntinfo; k++, tabf++) {
	    if (!(fflags[k]&2)) continue ;
	    /* If no column defined ==> keep it (V3.07; fixed V3.27) */
	    if ((c = strchr(t, '\n'))) *c = 0;
	    if (strstr(t,"name=") || strstr(t, "c=") || strstr(t, "*viz") 
	     || strstr(t, "source="))
	        set_mpos(tabf, bCollect.buf);
	    if (c) *c = '\n';
	}
    }

    /* We have now to define which columns of each table should
       be displayed by default.
       For this, we scan the table, and once a Table is found,
       we flag the corresponding table (to avoid to apply to
       def_columns algorithm for those tables)
    */
    memset(fflags, 0, cad->nfinfo);
    macro_name = "\\vizDisplayColumns" ;
    for (t = cad->more; *t; t++) {
    	t += next(t, macro_name);
    	if (! *t) break;
	if (! viz2(cad, t, fflags)) continue ;	/* fflags set to 2 for tables */
	flag_tabs(cad, fflags, tflags, TFLAG_DISP) ;	/* Keep marked tables */

	/* Loop in Column Fields */
	matching = anding = 0;			/* Default: exact names */
	/* Verify the type of assignment: * = all, - = all but, -* */
	setall = (bCollect.buf[0] == '-') || (strcmp(bCollect.buf, "*") == 0);
    	for (c = bCollect.buf; *c; ) {
	    if (setall) i = 1;
	    else {
		if ((*c == '*') && (!matching)) { matching = 1; c++; continue; }
		i = strloc(c, '\t');
	        if (i == 0) { c++; continue; }
    	        x = c[i]; c[i] = 0;
	    }
	    j = 0;
	    for (k=0, tabf=cad->atinfo; k < cad->ntinfo; k++, tabf++) {
	    	if (!(fflags[k]&2)) continue ;
		if (!tabf->nfmt) continue; /* No column */
		if (setall || matching) {
		    pf=tabf->afmt, ef=pf+tabf->nfmt ;
		    if (strcmp(pf->label, "recno") == 0)	/* V2.892 */
			pf++;
		}
    	        else pf = tbf_findlabel(tabf, c), ef = pf+1 ;
		if (pf) for (; pf<ef; pf++) {
		    if (pf->label[0] == '-') 	/* Not a valid label */
			continue;
		    if (matching && (!strmatch(c, pf->label)))	/* MisMatch */
			continue;
		    j++;			/* This column found */
		    if (anding)
			pf->flags &= ~F_DISP;
		    else {
			pf->flags |=  F_DISP;
		        if (pf->flags & F_NODB) fprintf(stderr,
		            "++++Column '%s' Displayed and Ignored, file: %s\n",
		            pf->label, files[k]->dfile);
		    }
	        }
    	        else fprintf(stderr,
    	    	    "++++Column '%s' not found for %s\n", c, macro_name);
	    }
	    if (j == 0) errors++, fprintf(stderr,
		"****Column '%s' not found in any table for %s\n",
		c, macro_name);
	    if (setall) { setall = 0; anding = 1; }
    	    else if ((c[i] = x)) c++;
    	    c += i;
    	}
    }

    /* Scan all table descriptions; for those not flagged,
    	we've to use the def_columns algorithm.
    */
    for (i=cad->nfinfo, file=cad->afinfo; --i>=0; file++) {
    	tabf = file->tabform;
    	if (!tabf) continue;
    	j = tabf - cad->atinfo;
    	if (tflags[j]&TFLAG_DISP) continue;	/* Already described */
    	def_columns(tabf, maxlen, maxcols, nposcol);
    	tflags[j] |= TFLAG_DISP;
    }

    free(files);
    free(fflags);
    errors += viz_errors() ;
    theCat = oldCat;
    return(errors);
}

#if DEBUG||TEST
#ifndef CATSTD_H		/* catstd.h file */
#define CATSTD_H "catstd.h"
#endif
#ifndef ITEMS
#define ITEMS(a)        sizeof(a)/sizeof(a[0])
#endif

/*==================================================================
		PROGRAM to Display the Column Statuses
 *==================================================================*/
static char flag_awk[] = "\
gawk '/ Other flags -----/ {print ""}\
/^#define F_/{print $2, $3}' ";
/*
static char flag_list[] = "\
gawk '/ Other flags -----/ {print ""}\
/^#define F_/{print $2, $3}' /usr/users/francois/src/anafile/catstd.h" ;
*/
static char *fexp[2][32] ;
static int  mask[2][32] ;
static int max_len = 255 ;
static FILINFO *thefile ;
static int interactive;
static char *tab_asked;

static int match_table(char *temp, char *name)
/*++++++++++++++++
.PURPOSE  Tells whether the name is included in the table template
.RETURNS  0 if no match / positive otherwise
-----------------*/
{
  char bname[80], *t;
  int lt=0, match=0, x;
    if (strlen(name) < sizeof(bname)-1) {
	strcpy(bname, name);
	bname[strloc(name,'.')] = 0;
	name = bname;
    }
    for (t=temp; *t; t += lt) { 
	if (*t == ' ') { lt=1; continue; }
	for (lt=0; isgraph(t[lt]); lt++) ;
	x = t[lt]; t[lt] = 0; 
	match = strmatch(t, name);
	t[lt] = x;
	if (match) return(match);
    }
    return(match);
}

static void print_hash(head, text)
/*++++++++++++++++
.PURPOSE  Print out, be sure each line starts by head
.RETURNS  -
-----------------*/
  char *head ;	/* IN: Header to issue    */
  char *text ;	/* IN: Text to issue    */
{
  char *p;
    printf("%s", head);
    for (p=text; *p; p++) {
	putchar(*p);
	if (*p == '\n') printf("%s", head);
    }
}

static void pr_noline(text, len, nl)
/*++++++++++++++++
.PURPOSE  Print out, but replace '\n' by the 'nl' string. Remove the blanks.
.RETURNS  -
-----------------*/
  char *text ;	/* IN: Text to issue    */
  int len;	/* IN: Length of Text   */
  char *nl ;	/* IN: Substitute of \n */
{
  char *p, *e;
  int lnl, imax ;
  char c = ' ' ;

    if (len < 0) len = strlen(text) ;
    imax = max_len ;
    lnl = strlen(nl)-1 ;

    for (p=text, e=p+len; (p<e) && *p; p++) {
	if (isspace(*p)) {
	    if (*p == '\n') imax -= lnl, printf("%s", nl) ;
	    else if (c != ' ') putchar(' ');
	    c = ' ' ;
	}
	else putchar(*p), c = *p ;
	if (--imax <= 0) break ;
    }
}

static void pr_csv(pc, ncols)
/*++++++++++++++++
.PURPOSE  Print out the column in CSV format
.RETURNS  -
-----------------*/
  COLINFO *pc ;	/* IN: Column to print	*/
  int ncols;	/* IN: number of columns existing at right of this one */
{
  SECTION *ps ;
  char *p, *m, *t;
  int k;

    p = pc->unit ;
    if (pc->flags&F_ACCU2) p = "{CPLX}";
    putchar(pc->ff);	
    /* V3.04: Add position location */
    if (csvp) { int b1 = pc->b1;
	if ((pc->flags&F_ACCU2) && (ncols>0)) 	/* Verify following */
	  for (k=1; k<ncols; k++) {
	    if ((pc[k].flags&(F_ACCU|F_ACCU2)) != F_ACCU) break;
	    b1 = pc[k].b1;
	}
	printf("[%d-%d]", pc->b0, b1);
    }
    printf("%c%s%c%s", csv, pc->label, csv, p) ;
    if (odim) {		/* Edit the unit Dimension */
	p = unit_dim(pc->unit);
	if (p && *p) printf("=%s", p);
    }
    putchar(csv);

    /* Skip the Range definitions */
    /* V2.85: Replace the explanation if more starts by !e= */
    m = pc->more;
    p = pc->text;
    if (m && (strncmp(m, "!e=", 3) == 0)) {	/* Change explanation */
	p = m+3;
	for (m += 3; *m && (*m != '!') && (*m != '='); m++) ;
    }
    if (*p == '*') p++;
    if (*p == '[') {
        if (*++p == ']') {	/* Accept old-style []? */
	    if (strchr(p+1, ']')) p++ ;
	}
        while (*p && *p != ']') p++ ;
        if (*p == ']') p++ ;
    }
    if ((*p == '?') && (p[1] == '=')){  /* Ignore the =... */
        putchar(' ') ;
        for (++p; isGraph(*p); p++) ;
    }
    pr_noline(p, -1, " ") ;

    /* Special F_ACCU2 */
    if (pc->flags&F_MPOS) {
        p = " {Coosys: " ;
        if (thefile->equinox) printf("%s Equinox=%s", p, thefile->equinox),
	    p = "" ;
        if (thefile->epoch)   printf("%s Epoch=%s",   p, thefile->epoch),
	    p = "" ;
        if (!*p)  putchar('}') ;
    }

    /* Print the UCD or vMore */
    putchar(csv) ;
    k = 0 ;			/* Indicates words, k='=' for a UCD */
    if ((p = strstr(pc->text, "\\ucd{" /*}*/))) {
	/* Transform the UCD if in the text */
	k = '=';		/* UCD added */
	putchar(k);
	p += 5;
	while (*p != '}') {	/* V2.89: accept ucd{UCD1=ucd1+} */
	    if (*p == '=') putchar('\t');
	    putchar(*p);
	    p++;
	}
    }
    else if (m) {
	/* Accept 2 UCDs separated by =
	   Several UCDs are possible (V2.89): if that's true,
	   put always UCD1 before UCD1+
	*/
	t = m+strloc(m, '\t');	/* V2.89: two UCDs separated by a tab or = */
	if (*t) *t = '=';
	p = m ;
	if (*p == '=') k = *(p++) ;
	else if (isalpha(*p) && strchr(p, '=')) {
	    /* The = in front of UCDs is missing ? */
	    while (isGraph(*p) || (*p == '=')) p++ ;
	    if (!*p) k = '=' ;
	    p = m ;
	}
	if (k) {		/* Yes, there are UCDs */
	    putchar(k) ;	/* ... and put UCD1 first */
	    if (*t && islower(*p)) {	/* UCD1+ is first */
		if (t[1] != '=') putchar(t[1]);
		printf("%s\t=", t+2);
		k = 2;
	    }
	    while (*p) {
		if (*p == '=') {
		    if (k == 2)	/* 2nd UCD alreay written out */
			break;
		    if (p[1] == '=') p++;	/* 2 consecutive = ? */
		    putchar('\t');
		}
		putchar(*p);
		p++;
	    }
	}
	else printf("%s", p);	/* Not a UCD, text */
	if (*t) *t = '\t';	/* Restore the tab */
    }
    /* Special Identifiers */
    else if (pc->value && (pc->flags&(F_LINK))) {
	printf("=DATA_LINK") ;
    }
    else if (pc->flags&(F_CATA|F_SIMB)) {
	printf("=%s",
	  pc->elims&F_NULL ? "ID_IDENTIFIER" : "ID_ALTERNATIVE"
	) ;
    }
    else if ((pc->flags&F_isFK) && (pc->elims&F_CCST)) {
        /* Signature of \vizAddFKflag */
	printf("=DATA_LINK") ;
    }
    /* Added Words from Flags -- but NOT after a UCD */
    if (!k) {
        if (pc->flags&F_isPK) printf(" main") ;
    }

    /* Print the note, if any */
    if ((ps = pc->note)) {
        putchar(csv) ;
	if ((p = ps->header)) pr_noline(p, -1, " ") ;
	if ((p = ps->abody))  pr_noline(p, ps->ebody - ps->abody, " ") ;
    }
}

/* Display the full status of a table (records, reclen, columns...) */
static void print_cat(pt)
/*++++++++++++++++
.PURPOSE  Show the list of a Catalog
.RETURNS  -
-----------------*/
  CATINFO *pt; 	/* IN: Table with details */
{
  FILINFO *pf; COLINFO *f;
  int fop, i, j, k;

    for (i=pt->nfinfo, pf=pt->afinfo; --i>=0; pf++) {
	thefile = pf ;
	if (tab_asked) {	/* V3.1: specify a table */
	    if (match_table(tab_asked, pf->dfile) == 0) continue;
	}
	if (csv) printf("\n#Table: %s\t", pf->dfile);
	else printf("----%s\t", pf->dfile);
	if (pf->tabform) {
	    printf("reclen=%d, records=%d", pf->reclen, pf->records);
	    if (pf->equinox) printf(", equinox=%s", pf->equinox) ;
	    if (pf->epoch) printf(", epoch=%s", pf->epoch) ;
	    if (pf->flags&F_NODB) printf("\t(IGNORE)");
	    putchar('\n') ;
	}
	else  { printf("(IGNORE)\n"); continue ; }
	if (csv) print_hash("#\t", pf->text); /* printf("#\t%s", pf->text) */
	else {
	    for (j = pf->tabform->nfmt, f = pf->tabform->afmt; --j>=0; f++) {
	        if (f->flags&F_DISP) printf("\t%s", f->label);
	    }
	    printf("\n");
	    printf("    Full Flags for Fields:");
	}
	if (interactive) printf(" (Hit Return)"), getchar() ;
	else printf("\n") ;

	/* Write out the Definitions of the Columns */
	for (j = pf->tabform->nfmt, f = pf->tabform->afmt; --j>=0; f++) {
	    if (csv) {
    		if ((f->flags & F_ACCU) && (!(f->flags&F_ACCU2))) /* Cplx...*/
        	  continue ;
	        printf("%s%c", pf->dfile, csv) ;
		pr_csv(f, j) ;
	    }
	    else { int sep;
	        printf("\t%-12s %04X %8X", f->label, f->elims & 0xFFFF,
		    f->flags);
	        for (fop=32, sep=' '; --fop >= 0; ) {
		    if (f->flags&mask[1][fop]) { 
			printf("%c%s", sep, fexp[1][fop]);
			sep = '|';
		    }
		}
		putchar(' ');
	        for (fop=32, sep='('; --fop >= 0; ) {
		    if (f->elims&mask[0][fop]) {
		        printf("%c%s", sep, fexp[0][fop]) ;
		        sep = '|';
		    }
		}
		if (sep == '|') putchar(')');
	    }
	    putchar('\n') ;
	}
	k = 0 ;
	if (!csv)
	for (j = pf->tabform->nfmt, f = pf->tabform->afmt; --j>=0; f++) {
	    if (!f->more) continue ;
	    if (k == 0) printf("    %s values:\n", vizMore);
	    k++ ;
	    printf("\t%-12s %s\n", f->label, f->more) ;
	}
    }
}

static int addLink2(BUFFER *b, CATINFO *readme, char *macro)
/*++++++++++++++++
.PURPOSE  Add the links from vizSimbad, etc (macros with 2 args)
.RETURNS  Number of additional links
.REMARKS  There can be several tables, separated by \v
-----------------*/
{
  char *t, *m, *vsep;
  int len, count=0;
    
    t = viz_getmac(readme, macro);
    if (!t) return(count);
    m = macro+1; if(strncmp(m, "viz", 3) == 0) m += 3;
    while(*t) {
      while(1) {
	if ((vsep = strchr(t, '\v'))) 		/* Added V3.27 */
	    *vsep = 0;
	len = strloc(t, '\t'); 
	if (b->used) BUF_AppendString(b, "\n");	/* Added V3.27 */
	BUF_AppendString(b, "\\vizLink{"); 
	BUF_AppendItems(b, char, t, len);	/* Add table name(s) */
	t += len; if (*t) t++;
	BUF_AppendString(b, "}{"); BUF_AppendString(b, m); /* e.g. "Simbad" */
	BUF_AppendString(b, "}{"); BUF_AppendString(b, m); /* e.g. "Simbad" */
	BUF_AppendString(b, "}{"); BUF_AppendString(b, t); /* e.g. '${Name}" */
	BUF_AppendString(b, "}{Link to "); BUF_AppendString(b, m); 
	BUF_AppendString(b, "}");
	count++;
	/* V3.27: several \vizSimbad? */
	if (vsep) { *vsep = '\v'; t = vsep+1; }
	else break;
      } 
      t += next(t, macro);
    }
    return(count);
}


/*==================================================================*/
int main (argc, argv)
/*++++++++++++++++
.PURPOSE  Just a TEST program
-----------------*/
  int argc;
  char **argv;
{
  static char *link2[] = { "\\vizSimbad", "\\vizNED", "\\vizLEDA" };
  static BUFFER badd   = BUF_Init(char, 512);
  CATINFO *pt; SECTION *ps ;
  char buf[512], *p, **a, *file;
  int fop, i, j, k, len;
  FILE *fflags;

    /* Get the explanations of Flags */
    p = strdup2(flag_awk, CATSTD_H);
    fflags = popen(p, "r") ;
    k = 0 ;
    while (fgets(buf, sizeof(buf), fflags)) {
	if (isspace(*buf)) { k++ ; continue ; }
	/*for (p=buf+strlen(buf)-1; *p != 'x'; p--) ;*/
	for (p=buf+strlen(buf)-1; *p != 'x'&&p != buf; p--) ;
	sscanf(p+1, "%x", &j) ;
	for (i=01, a=fexp[k]; i<j; i <<= 1, a++) ;
	if (i!=j) continue;    /* i==j -- unless composed flag (e.g. sofTeX) */
	if (*a) continue;      /* Already found -- keep first occurence only */
	p = *a = strdup(buf) ;
	mask[k][a-fexp[k]] = i ;
	while (isGraph(*p)) p++ ; *p = 0 ;
    }
    fclose(fflags) ;
    fop = FOP_quiet ;
    file = (char *)0 ;
    interactive = isatty(0) && isatty(1) ;

    while (-- argc > 0) {
	p = *++argv;
	if (*p == '-') switch (*++p) {
	  case 'v':                     /* Verbose      */
	    if (strncmp(p, "ver", 3) == 0) {
	        printf("vizcat (CDS) Version %s\n", VERSION);
	        exit(0);
	    }
	    fop |= FOP_v; fop &= ~FOP_quiet;
	    ++p;
	    /* osmtrace(1); */
	    continue;
	  case 'c':			/* Assume -csv	*/
	    if (strncmp(p, "csv", 3) == 0) {
		p += 3 ;
		if (*p == '+') csvp = *(p++);  /* V3.04 */
		if (*p == '=') p++ ;
		csv = *p ;
	    }
	    if (csv == 0) csv = '\t' ;
	    continue ;

	  case 'u':
	    if (p[1] == 'd')		/* Assume -udim	*/
		odim = 1;
	    else oucd=1,
		vizMore = "\\vizUCD";	/* Assume -ucd  */
	    continue ;

	  case 'h':			/* -help */
	    printf("%s%s", usage, help) ;
	    exit(0) ;

	  case 'f':			/* Format-File	*/
	    while(*++p) switch(*p) {
		case '.': fop |= FOP_dot; break;
		case '1': fop |= FOP_1;   break;
		case 's': fop |= FOP_std; break;
		case 'w': fop |= FOP_w;   break;
		case 'r': fop |= FOP_ra;  break;
		case 'X':
		case 'x': fop |= FOP_1X;  break;
		case 'v': fop |= FOP_v; fop &= ~FOP_quiet;  break;
		default:
		    fprintf(stderr, "\n****Bad format option: -%s\n", p);
		    fprintf(stderr, "%s", usage) ;
		    exit(1) ;
	    }
	    continue ;

	  case 't':	/* V3.1 */
	    if (argc<2) {
		fprintf(stderr, "\n#***table template missing after %s\n%s",
			p, usage);
		exit(1);
	    }
	    tab_asked = *++argv; argc--;
	    continue;

	  default:
	  /*bad_option:*/
	    fprintf(stderr, "\n****Bad option: -%s\n", p);
	    fprintf(stderr, "%s", usage) ;
	    exit(1) ;
	} else {
	    if (file) {
		fprintf(stderr, "****Only one file allowed...\n") ;
		fprintf(stderr, "%s", usage) ;
		exit(1) ;
	    }
	    file = p ;
        }
    }
    if (!file) {
	if (interactive) {
	    printf("----Description File: ");
	    if (!fgets(buf, sizeof(buf), stdin))
		exit(1);
	    for (i=strlen(buf)-1; i>=0; i--) {
		if (isspace(buf[i])) buf[i] = 0;
		else break;
	    }
	    file = buf;
	}
	else file = "ReadMe" ;
    }

    pt = cad_new(file, fop);
    if (!pt) {
	fprintf(stderr, "****Problems with file: %s\n", file) ;
	exit(1) ;
    }
    /* printf("....Status from ReadMe\n"); print_cat(pt); putchar('\n'); */

    /* Load all additional columns */
    if (viz_load(pt)<0) {	/* Added V3.26 */
	/*fprintf(stderr, "#***vizcat termined\n"); */
	exit(1);
    }


    /* V3.23: load the additional macros */
    for(i=0; i<ITEMS(link2); i++) 
	addLink2(&badd, pt, link2[i]);
    if(badd.used) {
	viz_addmore(pt, badd.buf);
        if (viz_load(pt)<0) 	/* Test added V3.27 */
	    exit(1);
    }

    /* Find all definitions */
    viz_set(pt, 75, 16, 1);
    viz_more(pt, vizMore) ;
    /* printf("====Will list the files:"); inbyte = getchar(); */

    /* Just set p to the Title of the Catalog */
    ps = pt->section[0];		/* Title */
    if (ps->class == SEC_Title) {
	p = ps->header ;
	if (!p) p = ps->abody ;
    }
    else p = "" ;

    /* Write a Title */
    if (csv) {
	putchar('#') ;
	len = strloc(p, '\n') ;
	if ((p+len) > ps->ebody) len = ps->ebody - p ;
	pr_noline(p, len, "") ;
	printf("\n\n#filename, datatype, label, units, explain, %s, Note",
	    vizMore) ;
    }
    else {
	printf("====Status of Columns for Catalog: ") ;
	while(isGraph(*p)) putchar(*p), p++ ;
    }
    putchar('\n') ;

    print_cat(pt);		/* EDIT the columns */

    if (interactive) { printf("\n====Will check===="); inbyte = getchar(); }
    cad_check(pt);
    if (!interactive) exit(0) ;

    while(1) {
	printf("----Give a key to look at (e.g. \\cUsualName or ADC): ");
	if (!fgets(buf, sizeof(buf), stdin)) break;
	if (! *buf) break;
	if (*buf == '\\') {
	    p = viz_getkey(pt, buf) ;
	    printf("viz_getkey===>'%s'\n", p ? p : "(NO SUCH KEY)") ;
	    p = viz_getmac(pt, buf) ;
	    printf("viz_getmac===>'%s'\n", p ? p : "(NO SUCH KEY)") ;
	}
	else printf("===>'%s'\n", p=cad_keywords(pt, buf)?p:"(nil)");
    }

    printf("\n====Will Kill everything===="); inbyte = getchar();
    cad_kill(pt);

    exit(0) ;
}
#endif
